/*************************************************************
 *
 *  Copyright (c) 2017 The MathJax Consortium
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */

import {CharMap} from '../../FontData.js';

export const sansSerifBold: CharMap = {
    0x20: [0, 0, .25],
    0x21: [.694, 0, .367, {css: 1}],
    0x22: [.694, -0.442, .558, {css: 1}],
    0x23: [.694, .193, .917, {css: 1}],
    0x24: [.75, .056, .55, {css: 1}],
    0x25: [.75, .056, 1.029, {css: 1}],
    0x26: [.716, .022, .831, {css: 1}],
    0x27: [.694, -0.442, .306, {css: 1}],
    0x28: [.75, .249, .428, {css: 1}],
    0x29: [.75, .25, .428, {css: 1}],
    0x2A: [.75, -0.293, .55, {css: 1}],
    0x2B: [.617, .116, .856, {css: 3}],
    0x2C: [.146, .106, .306, {css: 3}],
    0x2D: [.273, -0.186, .367, {css: 3}],
    0x2E: [.146, 0, .306, {css: 3}],
    0x2F: [.75, .249, .55, {css: 1}],
    0x30: [.715, .022, .55, {css: 3}],
    0x31: [.716, 0, .55, {css: 3}],
    0x32: [.716, 0, .55, {css: 3}],
    0x33: [.716, .022, .55, {css: 3}],
    0x34: [.694, 0, .55, {css: 3}],
    0x35: [.694, .022, .55, {css: 3}],
    0x36: [.716, .022, .55, {css: 3}],
    0x37: [.695, .011, .55, {css: 3}],
    0x38: [.715, .022, .55, {css: 3}],
    0x39: [.716, .022, .55, {css: 3}],
    0x3A: [.458, 0, .306, {css: 3}],
    0x3B: [.458, .106, .306, {css: 3}],
    0x3D: [.407, -0.094, .856, {css: 3}],
    0x3F: [.705, 0, .519, {css: 1}],
    0x40: [.704, .011, .733, {css: 1}],
    0x41: [.694, 0, .733, {css: 1}],
    0x42: [.694, 0, .733, {css: 1}],
    0x43: [.704, .011, .703, {css: 1}],
    0x44: [.694, 0, .794, {css: 1}],
    0x45: [.691, 0, .642, {css: 1}],
    0x46: [.691, 0, .611, {css: 1}],
    0x47: [.705, .011, .733, {css: 1}],
    0x48: [.694, 0, .794, {css: 1}],
    0x49: [.694, 0, .331, {css: 1}],
    0x4A: [.694, .022, .519, {css: 1}],
    0x4B: [.694, 0, .764, {css: 1}],
    0x4C: [.694, 0, .581, {css: 1}],
    0x4D: [.694, 0, .978, {css: 1}],
    0x4E: [.694, 0, .794, {css: 1}],
    0x4F: [.716, .022, .794, {css: 1}],
    0x50: [.694, 0, .703, {css: 1}],
    0x51: [.716, .106, .794, {css: 3}],
    0x52: [.694, 0, .703, {css: 1}],
    0x53: [.716, .022, .611, {css: 1}],
    0x54: [.688, 0, .733, {css: 1}],
    0x55: [.694, .022, .764, {css: 1}],
    0x56: [.694, 0, .733, {css: 1}],
    0x57: [.694, 0, 1.039, {css: 1}],
    0x58: [.694, 0, .733, {css: 1}],
    0x59: [.694, 0, .733, {css: 1}],
    0x5A: [.694, 0, .672, {css: 1}],
    0x5B: [.75, .25, .343, {css: 1}],
    0x5D: [.75, .25, .343, {css: 1}],
    0x5E: [.694, -0.537, .55, {css: 1}],
    0x5F: [-0.023, .11, .55, {css: 1}],
    0x61: [.475, .011, .525, {css: 3}],
    0x62: [.694, .01, .561, {css: 1}],
    0x63: [.475, .011, .489, {css: 3}],
    0x64: [.694, .011, .561, {css: 1}],
    0x65: [.474, .01, .511, {css: 3}],
    0x66: [.705, 0, .336, {css: 1}],
    0x67: [.469, .206, .55, {css: 3}],
    0x68: [.694, 0, .561, {css: 1}],
    0x69: [.695, 0, .256, {css: 1}],
    0x6A: [.695, .205, .286, {css: 1}],
    0x6B: [.694, 0, .531, {css: 1}],
    0x6C: [.694, 0, .256, {css: 1}],
    0x6D: [.469, 0, .867, {css: 3}],
    0x6E: [.468, 0, .561, {css: 3}],
    0x6F: [.474, .011, .55, {css: 3}],
    0x70: [.469, .194, .561, {css: 3}],
    0x71: [.469, .194, .561, {css: 3}],
    0x72: [.469, 0, .372, {css: 3}],
    0x73: [.474, .01, .422, {css: 3}],
    0x74: [.589, .01, .404, {css: 3}],
    0x75: [.458, .011, .561, {css: 3}],
    0x76: [.458, 0, .5, {css: 3}],
    0x77: [.458, 0, .744, {css: 3}],
    0x78: [.458, 0, .5, {css: 3}],
    0x79: [.458, .205, .5, {css: 3}],
    0x7A: [.458, 0, .476, {css: 3}],
    0x7E: [.344, -0.198, .55, {css: 1}],
    0xA0: [0, 0, .25],
    0x131: [.458, 0, .256, {css: 3}],
    0x237: [.458, .205, .286, {css: 3}],
    0x300: [.694, -0.537, 0],
    0x301: [.694, -0.537, 0],
    0x302: [.694, -0.537, 0],
    0x303: [.694, -0.548, 0],
    0x304: [.66, -0.56, 0, {css: 2}],
    0x306: [.694, -0.552, 0],
    0x307: [.695, -0.596, 0],
    0x308: [.695, -0.595, 0],
    0x30A: [.694, -0.538, 0],
    0x30B: [.694, -0.537, 0],
    0x30C: [.657, -0.5, 0],
    0x391: [.694, 0, .733, {css: 1}],
    0x392: [.694, 0, .733, {css: 1}],
    0x393: [.691, 0, .581, {css: 1}],
    0x394: [.694, 0, .917, {css: 1}],
    0x395: [.691, 0, .642, {css: 1}],
    0x396: [.694, 0, .672, {css: 1}],
    0x397: [.694, 0, .794, {css: 1}],
    0x398: [.716, .022, .856, {css: 1}],
    0x399: [.694, 0, .331, {css: 1}],
    0x39A: [.694, 0, .764, {css: 1}],
    0x39B: [.694, 0, .672, {css: 1}],
    0x39C: [.694, 0, .978, {css: 1}],
    0x39D: [.694, 0, .794, {css: 1}],
    0x39E: [.688, 0, .733, {css: 1}],
    0x39F: [.716, .022, .794, {css: 1}],
    0x3A0: [.691, 0, .794, {css: 1}],
    0x3A1: [.694, 0, .703, {css: 1}],
    0x3A2: [.716, .022, .856, {css: 1}],
    0x3A3: [.694, 0, .794, {css: 1}],
    0x3A4: [.688, 0, .733, {css: 1}],
    0x3A5: [.715, 0, .856, {css: 1}],
    0x3A6: [.694, 0, .794, {css: 1}],
    0x3A7: [.694, 0, .733, {css: 1}],
    0x3A8: [.694, 0, .856, {css: 1}],
    0x3A9: [.716, 0, .794, {css: 1}],
    0x3D2: [.715, 0, .856, {css: 1}],
    0x3DC: [.691, 0, .611, {css: 1}],
    0x2013: [.327, -0.24, .55, {css: 3}],
    0x2014: [.327, -0.24, 1.1, {css: 3}],
    0x2015: [.327, -0.24, 1.1, {css: 3}],
    0x2017: [-0.023, .11, .55, {css: 1}],
    0x2018: [.694, -0.443, .306, {css: 1}],
    0x2019: [.694, -0.442, .306, {css: 1}],
    0x201C: [.694, -0.443, .558, {css: 1}],
    0x201D: [.694, -0.442, .558, {css: 1}],
    0x2044: [.75, .249, .55, {css: 1}],
    0x2206: [.694, 0, .917, {css: 1}],
};
