/*************************************************************
 *
 *  Copyright (c) 2017 The MathJax Consortium
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */

import {CharMap} from '../../FontData.js';

export const sansSerif: CharMap = {
    0x20: [0, 0, .25],
    0x21: [.694, 0, .319, {css: 3}],
    0x22: [.694, -0.471, .5],
    0x23: [.694, .194, .833],
    0x24: [.75, .056, .5],
    0x25: [.75, .056, .833],
    0x26: [.716, .022, .758, {css: 1}],
    0x27: [.694, -0.471, .278],
    0x28: [.75, .25, .389],
    0x29: [.75, .25, .389],
    0x2A: [.75, -0.306, .5],
    0x2B: [.583, .082, .778],
    0x2C: [.098, .125, .278, {css: 2}],
    0x2D: [.259, -0.186, .333, {css: 2}],
    0x2E: [.098, 0, .278, {css: 2}],
    0x2F: [.75, .25, .5],
    0x30: [.678, .022, .5, {css: 2}],
    0x31: [.678, 0, .5, {css: 2}],
    0x32: [.677, 0, .5, {css: 2}],
    0x33: [.678, .022, .5, {css: 2}],
    0x34: [.656, 0, .5, {css: 2}],
    0x35: [.656, .021, .5, {css: 2}],
    0x36: [.677, .022, .5, {css: 2}],
    0x37: [.656, .011, .5, {css: 2}],
    0x38: [.678, .022, .5, {css: 2}],
    0x39: [.677, .022, .5, {css: 2}],
    0x3A: [.444, 0, .278, {css: 2}],
    0x3B: [.444, .125, .278, {css: 2}],
    0x3D: [.37, -0.13, .778],
    0x3F: [.704, 0, .472],
    0x40: [.704, .011, .667, {css: 1}],
    0x41: [.694, 0, .667, {css: 3}],
    0x42: [.694, 0, .667, {css: 3}],
    0x43: [.705, .011, .639, {css: 3}],
    0x44: [.694, 0, .722, {css: 3}],
    0x45: [.691, 0, .597, {css: 3}],
    0x46: [.691, 0, .569, {css: 3}],
    0x47: [.704, .011, .667, {css: 3}],
    0x48: [.694, 0, .708, {css: 3}],
    0x49: [.694, 0, .278, {css: 3}],
    0x4A: [.694, .022, .472, {css: 3}],
    0x4B: [.694, 0, .694, {css: 3}],
    0x4C: [.694, 0, .542, {css: 3}],
    0x4D: [.694, 0, .875, {css: 3}],
    0x4E: [.694, 0, .708, {css: 3}],
    0x4F: [.715, .022, .736, {css: 3}],
    0x50: [.694, 0, .639, {css: 3}],
    0x51: [.715, .125, .736, {css: 3}],
    0x52: [.694, 0, .646, {css: 3}],
    0x53: [.716, .022, .556, {css: 2}],
    0x54: [.688, 0, .681, {css: 3}],
    0x55: [.694, .022, .688, {css: 3}],
    0x56: [.694, 0, .667, {css: 3}],
    0x57: [.694, 0, .944, {css: 3}],
    0x58: [.694, 0, .667, {css: 3}],
    0x59: [.694, 0, .667, {css: 3}],
    0x5A: [.694, 0, .611, {css: 2}],
    0x5B: [.75, .25, .289, {css: 1}],
    0x5D: [.75, .25, .289, {css: 1}],
    0x5E: [.694, -0.527, .5],
    0x5F: [-0.038, .114, .5, {css: 2}],
    0x61: [.46, .01, .481, {css: 3}],
    0x62: [.694, .011, .517, {css: 1}],
    0x63: [.46, .01, .444, {css: 2}],
    0x64: [.694, .01, .517, {css: 1}],
    0x65: [.461, .01, .444, {css: 2}],
    0x66: [.705, 0, .306],
    0x67: [.455, .206, .5],
    0x68: [.694, 0, .517, {css: 1}],
    0x69: [.68, 0, .239, {css: 3}],
    0x6A: [.68, .205, .267, {css: 3}],
    0x6B: [.694, 0, .489, {css: 1}],
    0x6C: [.694, 0, .239, {css: 1}],
    0x6D: [.455, 0, .794, {css: 3}],
    0x6E: [.455, 0, .517, {css: 3}],
    0x6F: [.46, .01, .5, {css: 2}],
    0x70: [.455, .194, .517, {css: 3}],
    0x71: [.455, .194, .517, {css: 3}],
    0x72: [.455, 0, .342, {css: 3}],
    0x73: [.46, .01, .383, {css: 3}],
    0x74: [.571, .01, .361, {css: 3}],
    0x75: [.444, .01, .517, {css: 1}],
    0x76: [.444, 0, .461, {css: 3}],
    0x77: [.444, 0, .683, {css: 3}],
    0x78: [.444, 0, .461, {css: 3}],
    0x79: [.444, .204, .461, {css: 3}],
    0x7A: [.444, 0, .435, {css: 3}],
    0x7E: [.327, -0.193, .5, {css: 2}],
    0xA0: [0, 0, .25],
    0x131: [.444, 0, .239, {css: 1}],
    0x237: [.444, .205, .267, {css: 1}],
    0x300: [.694, -0.527, 0, {css: 2}],
    0x301: [.694, -0.527, 0, {css: 2}],
    0x302: [.694, -0.527, 0],
    0x303: [.677, -0.543, 0, {css: 2}],
    0x304: [.631, -0.552, 0, {css: 2}],
    0x306: [.694, -0.508, 0],
    0x307: [.68, -0.576, 0, {css: 2}],
    0x308: [.68, -0.582, 0, {css: 2}],
    0x30A: [.694, -0.527, 0, {css: 2}],
    0x30B: [.694, -0.527, 0, {css: 2}],
    0x30C: [.654, -0.487, 0, {css: 2}],
    0x391: [.694, 0, .667, {css: 3}],
    0x392: [.694, 0, .667, {css: 3}],
    0x393: [.691, 0, .542, {css: 3}],
    0x394: [.694, 0, .833, {css: 2}],
    0x395: [.691, 0, .597, {css: 3}],
    0x396: [.694, 0, .611, {css: 2}],
    0x397: [.694, 0, .708, {css: 3}],
    0x398: [.716, .021, .778, {css: 2}],
    0x399: [.694, 0, .278, {css: 3}],
    0x39A: [.694, 0, .694, {css: 3}],
    0x39B: [.694, 0, .611, {css: 3}],
    0x39C: [.694, 0, .875, {css: 3}],
    0x39D: [.694, 0, .708, {css: 3}],
    0x39E: [.688, 0, .667, {css: 2}],
    0x39F: [.715, .022, .736, {css: 3}],
    0x3A0: [.691, 0, .708, {css: 3}],
    0x3A1: [.694, 0, .639, {css: 3}],
    0x3A2: [.716, .021, .778, {css: 2}],
    0x3A3: [.694, 0, .722, {css: 2}],
    0x3A4: [.688, 0, .681, {css: 3}],
    0x3A5: [.716, 0, .778, {css: 2}],
    0x3A6: [.694, 0, .722, {css: 2}],
    0x3A7: [.694, 0, .667, {css: 3}],
    0x3A8: [.694, 0, .778, {css: 2}],
    0x3A9: [.716, 0, .722, {css: 2}],
    0x3D2: [.716, 0, .778, {css: 2}],
    0x3DC: [.691, 0, .569, {css: 3}],
    0x2013: [.312, -0.236, .5, {css: 2}],
    0x2014: [.312, -0.236, 1, {css: 2}],
    0x2015: [.312, -0.236, 1, {css: 2}],
    0x2017: [-0.038, .114, .5, {css: 2}],
    0x2018: [.694, -0.471, .278],
    0x2019: [.694, -0.471, .278],
    0x201C: [.694, -0.471, .5],
    0x201D: [.694, -0.471, .5],
    0x2044: [.75, .25, .5],
    0x2206: [.694, 0, .833, {css: 2}],
};
