/*************************************************************
 *
 *  Copyright (c) 2017 The MathJax Consortium
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */

import {CharMap} from '../../FontData.js';

export const scriptBold: CharMap = {
    0x20: [0, 0, .25],
    0x41: [.717, .008, .803, {ic: .213, sk: 0.389}],
    0x42: [.708, .028, .908, {sk: 0.194}],
    0x43: [.728, .026, .666, {ic: .153, sk: 0.278}],
    0x44: [.708, .031, .774, {ic: .081, sk: 0.111}],
    0x45: [.707, .008, .562, {ic: .156, sk: 0.139}],
    0x46: [.735, .036, .895, {ic: .095, sk: 0.222}],
    0x47: [.717, .037, .61, {ic: .128, sk: 0.25}],
    0x48: [.717, .036, .969, {ic: .272, sk: 0.333}],
    0x49: [.717, .017, .809, {ic: .137, sk: 0.333}],
    0x4A: [.717, .314, 1.052, {ic: .081, sk: 0.417}],
    0x4B: [.717, .037, .914, {ic: .29, sk: 0.361}],
    0x4C: [.717, .017, .874, {ic: .161, sk: 0.306}],
    0x4D: [.721, .05, 1.08, {ic: .136, sk: 0.444}],
    0x4E: [.726, .036, .902, {ic: .306, sk: 0.389}],
    0x4F: [.707, .008, .738, {ic: .067, sk: 0.167}],
    0x50: [.716, .037, 1.013, {sk: 0.222}],
    0x51: [.717, .017, .883, {sk: 0.278}],
    0x52: [.717, .017, .85, {sk: 0.194}],
    0x53: [.708, .036, .868, {ic: .148, sk: 0.333}],
    0x54: [.735, .037, .747, {ic: .249, sk: 0.222}],
    0x55: [.717, .017, .8, {ic: .16, sk: 0.25}],
    0x56: [.717, .017, .622, {ic: .228, sk: 0.222}],
    0x57: [.717, .017, .805, {ic: .221, sk: 0.25}],
    0x58: [.717, .017, .944, {ic: .187, sk: 0.278}],
    0x59: [.716, .017, .71, {ic: .249, sk: 0.194}],
    0x5A: [.717, .016, .821, {ic: .211, sk: 0.306}],
    0xA0: [0, 0, .25],
    0x391: [.698, 0, .869, {f: ''}],
    0x392: [.686, 0, .818, {f: ''}],
    0x395: [.68, 0, .756, {f: ''}],
    0x396: [.686, 0, .703, {f: ''}],
    0x397: [.686, 0, .9, {f: ''}],
    0x399: [.686, 0, .436, {f: ''}],
    0x39A: [.686, 0, .901, {f: ''}],
    0x39C: [.686, 0, 1.092, {f: ''}],
    0x39D: [.686, 0, .9, {f: ''}],
    0x39F: [.696, .01, .864, {f: ''}],
    0x3A1: [.686, 0, .786, {f: ''}],
    0x3A2: [.696, .01, .894, {f: ''}],
    0x3A4: [.675, 0, .8, {f: ''}],
    0x3A7: [.686, 0, .869, {f: ''}],
    0x3D2: [.697, 0, .894, {f: ''}],
    0x3DC: [.68, 0, .724, {f: ''}],
};
