/*************************************************************
 *
 *  Copyright (c) 2017 The MathJax Consortium
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */

import {CharMap} from '../../FontData.js';

export const texCaligraphic: CharMap = {
    0x20: [0, 0, .25],
    0x30: [.452, .022, .5, {css: 2}],
    0x31: [.453, 0, .5, {css: 2}],
    0x32: [.453, 0, .5, {css: 2}],
    0x33: [.452, .216, .5, {css: 2}],
    0x34: [.464, .194, .5, {css: 2}],
    0x35: [.453, .216, .5, {css: 2}],
    0x36: [.665, .022, .5],
    0x37: [.463, .216, .5, {css: 2}],
    0x38: [.666, .021, .5],
    0x39: [.453, .216, .5, {css: 2}],
    0x41: [.728, .05, .798, {sk: 0.194, css: 3}],
    0x42: [.705, .022, .657, {sk: 0.139, css: 3}],
    0x43: [.705, .025, .527, {sk: 0.139, css: 1}],
    0x44: [.683, 0, .771, {sk: 0.0833, css: 1}],
    0x45: [.705, .022, .528, {sk: 0.111, css: 3}],
    0x46: [.683, .032, .719, {ic: .11, sk: 0.111, css: 3}],
    0x47: [.704, .119, .595, {sk: 0.111, css: 3}],
    0x48: [.683, .048, .845, {sk: 0.111, css: 3}],
    0x49: [.683, 0, .545, {ic: .097, sk: 0.0278, css: 1}],
    0x4A: [.683, .119, .678, {ic: .161, sk: 0.167, css: 3}],
    0x4B: [.705, .022, .762, {sk: 0.0556, css: 3}],
    0x4C: [.705, .022, .69, {sk: 0.139, css: 3}],
    0x4D: [.705, .05, 1.201, {sk: 0.139, css: 3}],
    0x4E: [.789, .05, .82, {ic: .159, sk: 0.0833, css: 3}],
    0x4F: [.705, .022, .796, {sk: 0.111, css: 1}],
    0x50: [.683, .057, .696, {sk: 0.0833, css: 3}],
    0x51: [.705, .131, .817, {sk: 0.111, css: 3}],
    0x52: [.682, .022, .848, {sk: 0.0833, css: 1}],
    0x53: [.705, .022, .606, {sk: 0.139, css: 1}],
    0x54: [.717, .068, .545, {ic: .288, sk: 0.0278, css: 3}],
    0x55: [.683, .028, .626, {ic: .061, sk: 0.0833, css: 3}],
    0x56: [.683, .052, .613, {sk: 0.0278, css: 3}],
    0x57: [.683, .053, .988, {sk: 0.0833, css: 3}],
    0x58: [.683, 0, .713, {ic: .094, sk: 0.139, css: 1}],
    0x59: [.683, .143, .668, {sk: 0.0833, css: 3}],
    0x5A: [.683, 0, .725, {sk: 0.139, css: 1}],
    0xA0: [0, 0, .25],
    0x391: [.716, 0, .75, {sk: 0.139, f: ''}],
    0x392: [.683, 0, .759, {sk: 0.0833, f: ''}],
    0x395: [.68, 0, .738, {sk: 0.0833, f: ''}],
    0x396: [.683, 0, .683, {sk: 0.0833, f: ''}],
    0x397: [.683, 0, .831, {ic: .057, sk: 0.0556, f: ''}],
    0x399: [.683, 0, .44, {ic: .064, sk: 0.111, f: ''}],
    0x39A: [.683, 0, .849, {sk: 0.0556, f: ''}],
    0x39C: [.683, 0, .97, {ic: .081, sk: 0.0833, f: ''}],
    0x39D: [.683, 0, .803, {ic: .085, sk: 0.0833, f: ''}],
    0x39F: [.704, .022, .763, {sk: 0.0833, f: ''}],
    0x3A1: [.683, 0, .642, {ic: .109, sk: 0.0833, f: ''}],
    0x3A2: [.704, .022, .763, {sk: 0.0833, f: ''}],
    0x3A4: [.677, 0, .584, {ic: .12, sk: 0.0833, f: ''}],
    0x3A7: [.683, 0, .828, {sk: 0.0833, f: ''}],
    0x3D2: [.705, 0, .583, {ic: .117, sk: 0.0556, f: ''}],
    0x3DC: [.68, 0, .643, {ic: .106, sk: 0.0833, f: ''}],
};
