/*************************************************************
 *
 *  Copyright (c) 2017 The MathJax Consortium
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */

import {CharMap} from '../../FontData.js';

export const texSize4: CharMap = {
    0x20: [0, 0, .25],
    0x28: [1.75, 1.249, .792, {css: 3}],
    0x29: [1.75, 1.249, .792, {css: 3}],
    0x2F: [1.75, 1.249, 1.278, {css: 3}],
    0x5B: [1.75, 1.249, .583, {css: 3}],
    0x5C: [1.75, 1.249, 1.278, {css: 3}],
    0x5D: [1.75, 1.249, .583, {css: 3}],
    0x7B: [1.75, 1.249, .806, {css: 3}],
    0x7D: [1.75, 1.249, .806, {css: 3}],
    0xA0: [0, 0, .25],
    0x2C6: [.845, -0.561, 1.889, {css: 3}],
    0x2DC: [.823, -0.583, 1.889, {css: 3}],
    0x302: [.845, -0.561, 0, {css: 2}],
    0x303: [.823, -0.583, 0, {css: 2}],
    0x2044: [1.75, 1.249, 1.278, {css: 3}],
    0x221A: [1.75, 1.25, 1, {css: 3}],
    0x2308: [1.75, 1.249, .639, {css: 3}],
    0x2309: [1.75, 1.249, .639, {css: 3}],
    0x230A: [1.75, 1.249, .639, {css: 3}],
    0x230B: [1.75, 1.249, .639, {css: 3}],
    0x2329: [1.75, 1.248, .806, {css: 3}],
    0x232A: [1.75, 1.248, .806, {css: 3}],
    0x239B: [1.154, .655, .875, {c: '\\239B', css: 7}],
    0x239C: [.61, .01, .875, {c: '\\239C', css: 7}],
    0x239D: [1.165, .644, .875, {c: '\\239D', css: 7}],
    0x239E: [1.154, .655, .875, {c: '\\239E', css: 7}],
    0x239F: [.61, .01, .875, {c: '\\239F', css: 7}],
    0x23A0: [1.165, .644, .875, {c: '\\23A0', css: 7}],
    0x23A1: [1.154, .645, .667, {c: '\\23A1', css: 7}],
    0x23A2: [.602, 0, .667, {c: '\\23A2', css: 7}],
    0x23A3: [1.155, .644, .667, {c: '\\23A3', css: 7}],
    0x23A4: [1.154, .645, .667, {c: '\\23A4', css: 7}],
    0x23A5: [.602, 0, .667, {c: '\\23A5', css: 7}],
    0x23A6: [1.155, .644, .667, {c: '\\23A6', css: 7}],
    0x23A7: [.899, .01, .889, {c: '\\23A7', css: 7}],
    0x23A8: [1.16, .66, .889, {c: '\\23A8', css: 7}],
    0x23A9: [.01, .899, .889, {c: '\\23A9', css: 7}],
    0x23AA: [.29, .015, .889, {c: '\\23AA', css: 7}],
    0x23AB: [.899, .01, .889, {c: '\\23AB', css: 7}],
    0x23AC: [1.16, .66, .889, {c: '\\23AC', css: 7}],
    0x23AD: [.01, .899, .889, {c: '\\23AD', css: 7}],
    0x23B7: [.935, .885, 1.056, {c: '\\23B7', css: 7}],
    0x27E8: [1.75, 1.248, .806, {css: 3}],
    0x27E9: [1.75, 1.248, .806, {css: 3}],
    0x3008: [1.75, 1.248, .806, {css: 3}],
    0x3009: [1.75, 1.248, .806, {css: 3}],
    0xE000: [.625, .014, 1.056, {c: '\\E000', css: 7}],
    0xE001: [.605, .014, 1.056, {c: '\\E001', css: 7}],
    0xE150: [.12, .213, .45, {c: '\\E150', css: 7}],
    0xE151: [.12, .213, .45, {c: '\\E151', css: 7}],
    0xE152: [.333, 0, .45, {c: '\\E152', css: 7}],
    0xE153: [.333, 0, .45, {c: '\\E153', css: 7}],
    0xE154: [.32, .2, .4, {c: '\\E154', css: 7}],
    0xE155: [.333, 0, .9, {c: '\\E153\\E152', css: 7}],
    0xE156: [.12, .213, .9, {c: '\\E151\\E150', css: 7}],
};
