import { MathItem, ProtoItem } from './MathItem.js';
import { MmlNode } from './MmlTree/MmlNode.js';
import { OptionList } from '../util/Options.js';
import { FunctionList } from '../util/FunctionList.js';
export interface InputJax {
    name: string;
    processStrings: boolean;
    options: OptionList;
    preFilters: FunctionList;
    postFilters: FunctionList;
    findMath(which: Element | string[], options?: OptionList): ProtoItem[];
    compile(math: MathItem): MmlNode;
}
export declare abstract class AbstractInputJax implements InputJax {
    static NAME: string;
    static OPTIONS: OptionList;
    options: OptionList;
    preFilters: FunctionList;
    postFilters: FunctionList;
    constructor(options?: OptionList);
    readonly name: string;
    readonly processStrings: boolean;
    findMath(node: Element | string[], options: OptionList): ProtoItem[];
    abstract compile(math: MathItem): MmlNode;
    protected executeFilters(filters: FunctionList, math: MathItem, data: any): any;
}
