import { OptionList } from '../util/Options.js';
import { MathDocument } from './MathDocument.js';
import { MathItem } from './MathItem.js';
export interface OutputJax {
    name: string;
    options: OptionList;
    typeset(math: MathItem, document?: MathDocument): Element;
    escaped(math: MathItem, document?: MathDocument): Element;
    getMetrics(document: MathDocument): void;
    styleSheet(document: MathDocument): Element;
}
export declare abstract class AbstractOutputJax implements OutputJax {
    static NAME: string;
    static OPTIONS: OptionList;
    options: OptionList;
    constructor(options?: OptionList);
    readonly name: string;
    abstract typeset(math: MathItem, document?: MathDocument): Element;
    abstract escaped(math: MathItem, document?: MathDocument): Element;
    getMetrics(document: MathDocument): void;
    styleSheet(document: MathDocument): Element;
}
