import { AbstractMathDocument } from '../../core/MathDocument.js';
import { OptionList } from '../../util/Options.js';
import { HTMLMathItem } from './HTMLMathItem.js';
import { HTMLDomStrings } from './HTMLDomStrings.js';
import { InputJax } from '../../core/InputJax.js';
import { ProtoItem, Location } from '../../core/MathItem.js';
export declare type HTMLNodeArray = [Element, number][][];
export declare class HTMLDocument extends AbstractMathDocument {
    static KIND: string;
    static OPTIONS: OptionList;
    static STATE: {
        UNPROCESSED: number;
        COMPILED: number;
        TYPESET: number;
        INSERTED: number;
    };
    domStrings: HTMLDomStrings;
    constructor(document: any, options: OptionList);
    protected findPosition(N: number, index: number, delim: string, nodes: HTMLNodeArray): Location;
    protected mathItem(item: ProtoItem, jax: InputJax, nodes: HTMLNodeArray): HTMLMathItem;
    protected getElements(nodes: (string | Element | Element[])[], document: Document): Element[];
    findMath(options: OptionList): this;
    updateDocument(): this;
    removeFromDocument(restore?: boolean): this;
    documentStyleSheet(): Element;
    TestMath(text: string, display?: boolean): this;
}
