"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Handler_js_1 = require("../../core/Handler.js");
var HTMLDocument_js_1 = require("./HTMLDocument.js");
var DOM_js_1 = require("../../util/DOM.js");
var HTMLHandler = (function (_super) {
    __extends(HTMLHandler, _super);
    function HTMLHandler(priority) {
        if (priority === void 0) { priority = 5; }
        var _this = _super.call(this, priority) || this;
        _this.parser = new (DOM_js_1.DOM.DOMParser)();
        return _this;
    }
    HTMLHandler.prototype.handlesDocument = function (document) {
        if (typeof (document) === 'string') {
            try {
                document = this.parser.parseFromString(document, 'text/html');
            }
            catch (err) { }
        }
        if (document instanceof DOM_js_1.DOM.window.Document ||
            document instanceof DOM_js_1.DOM.window.HTMLElement ||
            document instanceof DOM_js_1.DOM.window.DocumentFragment) {
            return true;
        }
        return false;
    };
    HTMLHandler.prototype.create = function (document, options) {
        if (typeof (document) === 'string') {
            document = this.parser.parseFromString(document, 'text/html');
        }
        else if (document instanceof DOM_js_1.DOM.window.HTMLElement ||
            document instanceof DOM_js_1.DOM.window.DocumentFragment) {
            var child = document;
            document = this.parser.parseFromString('', 'text/html');
            document.body.appendChild(child);
        }
        return new HTMLDocument_js_1.HTMLDocument(document, options);
    };
    return HTMLHandler;
}(Handler_js_1.AbstractHandler));
exports.HTMLHandler = HTMLHandler;
//# sourceMappingURL=HTMLHandler.js.map