"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var MathItem_js_1 = require("../../core/MathItem.js");
var HTMLMathItem = (function (_super) {
    __extends(HTMLMathItem, _super);
    function HTMLMathItem(math, jax, display, start, end) {
        if (display === void 0) { display = true; }
        if (start === void 0) { start = { node: null, n: 0, delim: '' }; }
        if (end === void 0) { end = { node: null, n: 0, delim: '' }; }
        return _super.call(this, math, jax, display, start, end) || this;
    }
    HTMLMathItem.prototype.addEventHandlers = function () { };
    HTMLMathItem.prototype.updateDocument = function (html) {
        if (this.state() < STATE.INSERTED) {
            if (this.inputJax.processStrings) {
                var node = this.start.node;
                if (node === this.end.node) {
                    if (this.end.n < this.end.node.nodeValue.length) {
                        this.end.node.splitText(this.end.n);
                    }
                    if (this.start.n) {
                        node = this.start.node.splitText(this.start.n);
                    }
                    node.parentNode.replaceChild(this.typesetRoot, node);
                }
                else {
                    if (this.start.n) {
                        node = node.splitText(this.start.n);
                    }
                    while (node !== this.end.node) {
                        var next = node.nextSibling;
                        node.parentNode.removeChild(node);
                        node = next;
                    }
                    node.parentNode.insertBefore(this.typesetRoot, node);
                    if (this.end.n < node.nodeValue.length) {
                        node.splitText(this.end.n);
                    }
                    node.parentNode.removeChild(node);
                }
            }
            else {
                this.start.node.parentNode.replaceChild(this.typesetRoot, this.start.node);
            }
            this.start.node = this.end.node = this.typesetRoot;
            this.start.n = this.end.n = 0;
            this.state(STATE.INSERTED);
        }
    };
    HTMLMathItem.prototype.removeFromDocument = function (restore) {
        if (restore === void 0) { restore = false; }
        if (this.state() >= STATE.TYPESET) {
            var node = this.start.node;
            if (restore) {
                var document_1 = node.ownerDocument;
                var text = this.start.delim + this.math + this.end.delim;
                var math = void 0;
                if (this.inputJax.processStrings) {
                    math = document_1.createTextNode(text);
                }
                else {
                    var span = document_1.createElement('span');
                    span.innerHTML = text;
                    math = span.firstChild;
                }
                node.parentNode.insertBefore(math, node);
            }
            node.parentNode.removeChild(node);
        }
    };
    return HTMLMathItem;
}(MathItem_js_1.AbstractMathItem));
HTMLMathItem.STATE = MathItem_js_1.AbstractMathItem.STATE;
exports.HTMLMathItem = HTMLMathItem;
var STATE = HTMLMathItem.STATE;
//# sourceMappingURL=HTMLMathItem.js.map