import { AbstractFindMath } from '../../core/FindMath.js';
import { OptionList } from '../../util/Options.js';
import { ProtoItem } from '../../core/MathItem.js';
export declare type EndItem = [string, boolean, RegExp];
export declare type Delims = [string, string];
export declare class FindAsciiMath extends AbstractFindMath {
    static OPTIONS: OptionList;
    protected start: RegExp;
    protected end: {
        [name: string]: EndItem;
    };
    protected hasPatterns: boolean;
    constructor(options: OptionList);
    protected getPatterns(): void;
    protected addPattern(starts: string[], delims: Delims, display: boolean): void;
    protected findEnd(text: string, n: number, start: RegExpExecArray, end: EndItem): ProtoItem;
    protected findMathInString(math: ProtoItem[], n: number, text: string): void;
    findMath(strings: string[]): ProtoItem[];
}
