import { AbstractInputJax } from '../core/InputJax.js';
import { OptionList } from '../util/Options.js';
import { FunctionList } from '../util/FunctionList.js';
import { MathItem } from '../core/MathItem.js';
import { FindMathML } from './mathml/FindMathML.js';
import { MathMLCompile } from './mathml/MathMLCompile.js';
export declare class MathML extends AbstractInputJax {
    static NAME: string;
    static OPTIONS: OptionList;
    protected findMathML: FindMathML;
    protected mathml: MathMLCompile;
    protected parser: DOMParser;
    protected mmlFilters: FunctionList;
    constructor(options?: OptionList);
    readonly processStrings: boolean;
    compile(math: MathItem): any;
    protected checkForErrors(doc: Document): Document;
    protected error(message: string): void;
    findMath(node: Element): {
        math: string;
        start: {
            i?: number;
            n?: number;
            delim?: string;
            node?: Element | Text;
        };
        end: {
            i?: number;
            n?: number;
            delim?: string;
            node?: Element | Text;
        };
        open?: string;
        close?: string;
        n?: number;
        display: boolean;
    }[];
}
