"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var InputJax_js_1 = require("../core/InputJax.js");
var Options_js_1 = require("../util/Options.js");
var FunctionList_js_1 = require("../util/FunctionList.js");
var DOM_js_1 = require("../util/DOM.js");
var FindMathML_js_1 = require("./mathml/FindMathML.js");
var MathMLCompile_js_1 = require("./mathml/MathMLCompile.js");
var MathML = (function (_super) {
    __extends(MathML, _super);
    function MathML(options) {
        if (options === void 0) { options = {}; }
        var _this = this;
        var _a = __read(Options_js_1.separateOptions(options, FindMathML_js_1.FindMathML.OPTIONS, MathMLCompile_js_1.MathMLCompile.OPTIONS), 3), mml = _a[0], find = _a[1], compile = _a[2];
        _this = _super.call(this, mml) || this;
        _this.findMathML = _this.options['FindMathML'] || new FindMathML_js_1.FindMathML(find);
        _this.mathml = _this.options['MathMLCompile'] || new MathMLCompile_js_1.MathMLCompile(compile);
        _this.parser = _this.options['DOMParser'] || new (DOM_js_1.DOM.DOMParser)();
        _this.mmlFilters = new FunctionList_js_1.FunctionList();
        return _this;
    }
    Object.defineProperty(MathML.prototype, "processStrings", {
        get: function () {
            return false;
        },
        enumerable: true,
        configurable: true
    });
    MathML.prototype.compile = function (math) {
        var mml = math.start.node;
        if (!mml || this.options['forceReparse']) {
            var mathml = this.executeFilters(this.preFilters, math, math.math || '<math></math>');
            var doc = this.parser.parseFromString(mathml, 'text/' + this.options['parseAs']);
            doc = this.checkForErrors(doc);
            if (doc.body) {
                if (doc.body.childNodes.length !== 1) {
                    this.error('MathML must consist of a single element');
                }
                mml = doc.body.removeChild(doc.body.firstChild);
            }
            else {
                mml = doc.removeChild(doc.firstChild);
            }
            if (mml.nodeName.toLowerCase().replace(/^[a-z]+:/, '') !== 'math') {
                this.error('MathML must be formed by a <math> element, not <' +
                    mml.nodeName.toLowerCase() + '>');
            }
        }
        mml = this.executeFilters(this.mmlFilters, math, mml);
        return this.executeFilters(this.postFilters, math, this.mathml.compile(mml));
    };
    MathML.prototype.checkForErrors = function (doc) {
        var err = doc.querySelector('parsererror');
        if (err) {
            if (err.textContent === '') {
                this.error('Error processing MathML');
            }
            this.options['parseError'].call(this, err);
        }
        return doc;
    };
    MathML.prototype.error = function (message) {
        throw new Error(message);
    };
    MathML.prototype.findMath = function (node) {
        return this.findMathML.findMath(node);
    };
    return MathML;
}(InputJax_js_1.AbstractInputJax));
MathML.NAME = 'MathML';
MathML.OPTIONS = Options_js_1.defaultOptions({
    parseAs: 'html',
    forceReparse: false,
    FindMathML: null,
    MathMLCompile: null,
    DOMParser: null,
    parseError: function (node) {
        this.error(node.textContent.replace(/\n.*/g, ''));
    }
}, InputJax_js_1.AbstractInputJax.OPTIONS);
exports.MathML = MathML;
//# sourceMappingURL=mathml.js.map