import { MmlFactory } from '../../core/MmlTree/MmlFactory.js';
import { MmlEntities } from './MmlEntities.js';
import { MmlNode } from '../../core/MmlTree/MmlNode.js';
import { OptionList } from '../../util/Options.js';
export declare class MathMLCompile {
    static OPTIONS: OptionList;
    static VERIFY: OptionList;
    protected factory: MmlFactory;
    protected entities: MmlEntities;
    protected options: OptionList;
    constructor(options?: OptionList);
    compile(node: HTMLElement): MmlNode;
    makeNode(node: HTMLElement): MmlNode;
    protected addAttributes(mml: MmlNode, node: HTMLElement): void;
    protected filterAttribute(name: string, value: string): string;
    protected addChildren(mml: MmlNode, node: HTMLElement): void;
    protected addText(mml: MmlNode, child: HTMLElement): void;
    protected checkClass(mml: MmlNode, node: HTMLElement): void;
    protected texAtom(mml: MmlNode, texClass: string, limits: boolean): void;
    protected markMrows(mml: MmlNode): void;
    protected trimSpace(text: string): string;
    protected error(message: string): void;
}
