import { MmlNode } from '../../core/MmlTree/MmlNode.js';
import { StackItem, EnvList } from './StackItem.js';
import Stack from './Stack.js';
import { SymbolMap } from './SymbolMap.js';
import TexParser from './TexParser.js';
import { ParseMethod } from './Types.js';
export declare class OldParser {
    readonly ParseMethods: Record<string, ParseMethod>;
    NBSP: string;
    string: string;
    NewParser: TexParser;
    macroCount: number;
    i: number;
    remap: SymbolMap;
    stack: Stack;
    constructor(str: string, env: EnvList, ParseMethods: Record<string, ParseMethod>);
    Parse(): void;
    Push(arg: StackItem | MmlNode): void;
    PushAll(args: (StackItem | MmlNode)[]): void;
    mml(): MmlNode;
    mmlToken(token: MmlNode): MmlNode;
    convertDelimiter(c: string): string;
    trimSpaces(text: string): string;
    nextIsSpace(): RegExpMatchArray;
    GetNext(): string;
    GetCS(name?: string): string;
    GetArgument(name: string, noneOK?: boolean): string;
    GetBrackets(name: string, def?: string): string;
    GetDelimiter(name: string, braceOK?: boolean): string;
    GetDimen(name: string): string;
    GetUpTo(name: string, token: string): string;
    ParseArg(name: string): MmlNode;
    ParseUpTo(name: string, token: string): MmlNode;
    InternalMath(text: string, level?: number | string): MmlNode[];
    InternalText(text: string, def: EnvList): MmlNode;
    GetDelimiterArg(name: string): string;
    GetStar(): boolean;
}
