"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var TreeHelper_js_1 = require("./TreeHelper.js");
var StackItem_js_1 = require("./StackItem.js");
var Stack = (function () {
    function Stack(env, inner) {
        this.data = [];
        this.env = {};
        this.global = {};
        this.global = { isInner: inner };
        var item = new StackItem_js_1.StartItem(this.global);
        this.data = [
            new StackItem_js_1.StartItem(this.global)
        ];
        if (env) {
            this.data[0].env = env;
        }
        this.env = this.data[0].env;
    }
    Stack.prototype.Push = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        TreeHelper_js_1.TreeHelper.printSimple("PUSHING onto stack: ");
        TreeHelper_js_1.TreeHelper.printSimple(args.toString());
        for (var i = 0, m = args.length; i < m; i++) {
            var item = arguments[i];
            if (!item)
                continue;
            if (TreeHelper_js_1.TreeHelper.isNode(item)) {
                item = new StackItem_js_1.MmlItem(item);
            }
            item.global = this.global;
            var top_1 = (this.data.length ? this.Top().checkItem(item) : true);
            if (top_1 instanceof Array) {
                this.Pop();
                this.Push.apply(this, top_1);
            }
            else if (top_1 instanceof StackItem_js_1.BaseItem) {
                this.Pop();
                this.Push(top_1);
            }
            else if (top_1) {
                this.data.push(item);
                if (item.env) {
                    if (item.copyEnv !== false) {
                        for (var id in this.env) {
                            if (this.env.hasOwnProperty(id)) {
                                item.env[id] = this.env[id];
                            }
                        }
                    }
                    this.env = item.env;
                }
                else {
                    item.env = this.env;
                }
            }
        }
    };
    Stack.prototype.Pop = function () {
        var item = this.data.pop();
        if (!item.isOpen) {
            delete item.env;
        }
        this.env = (this.data.length ? this.Top().env : {});
        return item;
    };
    Stack.prototype.Top = function (n) {
        if (n == null) {
            n = 1;
        }
        if (this.data.length < n) {
            return null;
        }
        return this.data[this.data.length - n];
    };
    Stack.prototype.Prev = function (noPop) {
        var top = this.Top();
        if (noPop) {
            return top.data[top.data.length - 1];
        }
        else {
            return top.Pop();
        }
    };
    Stack.prototype.toString = function () {
        return 'stack[\n  ' + this.data.join('\n  ') + '\n]';
    };
    return Stack;
}());
exports.default = Stack;
//# sourceMappingURL=Stack.js.map