"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var Symbol_js_1 = require("./Symbol.js");
var MapHandler_js_1 = require("./MapHandler.js");
var AbstractSymbolMap = (function () {
    function AbstractSymbolMap(_name) {
        this._name = _name;
        MapHandler_js_1.default.getInstance().register(this);
    }
    ;
    Object.defineProperty(AbstractSymbolMap.prototype, "name", {
        get: function () {
            return this._name;
        },
        enumerable: true,
        configurable: true
    });
    AbstractSymbolMap.prototype.parserFor = function (symbol) {
        return this.contains(symbol) ? this.parser : null;
    };
    AbstractSymbolMap.prototype.parse = function (_a) {
        var _b = __read(_a, 2), symbol = _b[0], env = _b[1];
        var parser = this.parserFor(symbol);
        var mapped = this.lookup(symbol);
        return (parser && mapped) ? (parser.bind(env)(env, mapped) || true) : null;
    };
    Object.defineProperty(AbstractSymbolMap.prototype, "parser", {
        get: function () {
            return this._parser;
        },
        set: function (parser) {
            this._parser = parser;
        },
        enumerable: true,
        configurable: true
    });
    return AbstractSymbolMap;
}());
exports.AbstractSymbolMap = AbstractSymbolMap;
var RegExpMap = (function (_super) {
    __extends(RegExpMap, _super);
    function RegExpMap(name, _regExp) {
        var _this = _super.call(this, name) || this;
        _this._regExp = _regExp;
        return _this;
    }
    RegExpMap.create = function (name, parser, regexp) {
        var map = new RegExpMap(name, regexp);
        map.parser = parser;
        return map;
    };
    ;
    RegExpMap.prototype.contains = function (symbol) {
        return this._regExp.test(symbol);
    };
    RegExpMap.prototype.lookup = function (symbol) {
        return this.contains(symbol) ? symbol : null;
    };
    return RegExpMap;
}(AbstractSymbolMap));
exports.RegExpMap = RegExpMap;
var AbstractParseMap = (function (_super) {
    __extends(AbstractParseMap, _super);
    function AbstractParseMap() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.map = new Map();
        return _this;
    }
    AbstractParseMap.prototype.lookup = function (symbol) {
        return this.map.get(symbol);
    };
    AbstractParseMap.prototype.contains = function (symbol) {
        return this.map.has(symbol);
    };
    AbstractParseMap.prototype.add = function (symbol, object) {
        this.map.set(symbol, object);
    };
    return AbstractParseMap;
}(AbstractSymbolMap));
exports.AbstractParseMap = AbstractParseMap;
var CharacterMap = (function (_super) {
    __extends(CharacterMap, _super);
    function CharacterMap() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CharacterMap.addCharacters = function (map, json) {
        for (var key in json) {
            var value = json[key];
            map.addElement(key, (typeof (value) === 'string') ? [value, null] : value);
        }
    };
    CharacterMap.create = function (name, parser, json) {
        var map = new CharacterMap(name);
        CharacterMap.addCharacters(map, json);
        map.parser = parser;
        return map;
    };
    CharacterMap.prototype.addElement = function (symbol, pair) {
        var character = new Symbol_js_1.Symbol(symbol, pair[0], pair[1]);
        this.add(symbol, character);
    };
    return CharacterMap;
}(AbstractParseMap));
exports.CharacterMap = CharacterMap;
var DelimiterMap = (function (_super) {
    __extends(DelimiterMap, _super);
    function DelimiterMap() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    DelimiterMap.create = function (name, parser, json) {
        var map = new DelimiterMap(name);
        map.parser = parser;
        CharacterMap.addCharacters(map, json);
        return map;
    };
    DelimiterMap.prototype.parse = function (_a) {
        var _b = __read(_a, 2), symbol = _b[0], env = _b[1];
        return _super.prototype.parse.call(this, ['\\' + symbol, env]);
    };
    return DelimiterMap;
}(CharacterMap));
exports.DelimiterMap = DelimiterMap;
var MacroMap = (function (_super) {
    __extends(MacroMap, _super);
    function MacroMap() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    MacroMap.addCommands = function (map, json) {
        for (var key in json) {
            var value = json[key];
            map.addElement(key, (typeof (value) === 'string') ? [value] : value);
        }
    };
    MacroMap.create = function (name, json) {
        var map = new MacroMap(name);
        MacroMap.addCommands(map, json);
        return map;
    };
    Object.defineProperty(MacroMap.prototype, "functionMap", {
        set: function (map) {
            this._functionMap = map;
        },
        enumerable: true,
        configurable: true
    });
    MacroMap.prototype.parserFor = function (symbol) {
        var macro = this.lookup(symbol);
        return macro ? this._functionMap[macro.func] : null;
    };
    MacroMap.prototype.addElement = function (symbol, object) {
        var character = new Symbol_js_1.Macro(symbol, object[0], object.slice(1));
        this.add(symbol, character);
    };
    return MacroMap;
}(AbstractParseMap));
exports.MacroMap = MacroMap;
var CommandMap = (function (_super) {
    __extends(CommandMap, _super);
    function CommandMap() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CommandMap.create = function (name, json) {
        var map = new CommandMap(name);
        MacroMap.addCommands(map, json);
        return map;
    };
    CommandMap.prototype.parse = function (_a) {
        var _b = __read(_a, 2), symbol = _b[0], env = _b[1];
        var macro = this.lookup(symbol);
        var parser = this.parserFor(symbol);
        if (!macro || !parser) {
            return null;
        }
        var args = [env, '\\' + symbol].concat(macro.args);
        return parser ? (parser.bind(env).apply(env, args) || true) : null;
    };
    return CommandMap;
}(MacroMap));
exports.CommandMap = CommandMap;
var EnvironmentMap = (function (_super) {
    __extends(EnvironmentMap, _super);
    function EnvironmentMap() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    EnvironmentMap.create = function (name, json) {
        var map = new EnvironmentMap(name);
        MacroMap.addCommands(map, json);
        return map;
    };
    EnvironmentMap.prototype.parse = function (_a) {
        var _b = __read(_a, 2), symbol = _b[0], env = _b[1];
        var macro = this.lookup(symbol);
        var envParser = this.parserFor(symbol);
        if (!macro || !envParser) {
            return null;
        }
        this.parser.bind(env)(env, envParser.bind(env), symbol, macro.args);
        return true;
    };
    return EnvironmentMap;
}(MacroMap));
exports.EnvironmentMap = EnvironmentMap;
//# sourceMappingURL=SymbolMap.js.map