"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var TexConstant;
(function (TexConstant) {
    TexConstant.Inherit = '_inherit_';
    TexConstant.Auto = '_auto_';
    TexConstant.Size = {
        INFINITY: 'infinity',
        SMALL: 'small',
        NORMAL: 'normal',
        BIG: 'big'
    };
    TexConstant.Color = {
        TRANSPARENT: 'transparent'
    };
    TexConstant.Variant = {
        NORMAL: 'normal',
        BOLD: 'bold',
        ITALIC: 'italic',
        BOLDITALIC: 'bold-italic',
        DOUBLESTRUCK: 'double-struck',
        FRAKTUR: 'fraktur',
        BOLDFRAKTUR: 'bold-fraktur',
        SCRIPT: 'script',
        BOLDSCRIPT: 'bold-script',
        SANSSERIF: 'sans-serif',
        BOLDSANSSERIF: 'bold-sans-serif',
        SANSSERIFITALIC: 'sans-serif-italic',
        SANSSERIFBOLDITALIC: 'sans-serif-bold-italic',
        MONOSPACE: 'monospace',
        INITIAL: 'inital',
        TAILED: 'tailed',
        LOOPED: 'looped',
        STRETCHED: 'stretched',
        CALIGRAPHIC: '-tex-caligraphic',
        OLDSTYLE: '-tex-oldstyle'
    };
    TexConstant.Form = {
        PREFIX: 'prefix',
        INFIX: 'infix',
        POSTFIX: 'postfix'
    };
    TexConstant.LineBreak = {
        AUTO: 'auto',
        NEWLINE: 'newline',
        NOBREAK: 'nobreak',
        GOODBREAK: 'goodbreak',
        BADBREAK: 'badbreak'
    };
    TexConstant.LineBreakStyle = {
        BEFORE: 'before',
        AFTER: 'after',
        DUPLICATE: 'duplicate',
        INFIXLINBREAKSTYLE: 'infixlinebreakstyle'
    };
    TexConstant.IndentAlign = {
        LEFT: 'left',
        CENTER: 'center',
        RIGHT: 'right',
        AUTO: 'auto',
        ID: 'id',
        INDENTALIGN: 'indentalign'
    };
    TexConstant.IndentShift = {
        INDENTSHIFT: 'indentshift'
    };
    TexConstant.LineThickness = {
        THIN: 'thin',
        MEDIUM: 'medium',
        THICK: 'thick'
    };
    TexConstant.Notation = {
        LONGDIV: 'longdiv',
        ACTUARIAL: 'actuarial',
        RADICAL: 'radical',
        BOX: 'box',
        ROUNDEDBOX: 'roundedbox',
        CIRCLE: 'circle',
        LEFT: 'left',
        RIGHT: 'right',
        TOP: 'top',
        BOTTOM: 'bottom',
        UPDIAGONALSTRIKE: 'updiagonalstrike',
        DOWNDIAGONALSTRIKE: 'downdiagonalstrike',
        UPDIAGONALARROW: 'updiagonalarrow',
        VERTICALSTRIKE: 'verticalstrike',
        HORIZONTALSTRIKE: 'horizontalstrike',
        PHASORANGLE: 'phasorangle',
        MADRUWB: 'madruwb'
    };
    TexConstant.Align = {
        TOP: 'top',
        BOTTOM: 'bottom',
        CENTER: 'center',
        BASELINE: 'baseline',
        AXIS: 'axis',
        LEFT: 'left',
        RIGHT: 'right'
    };
    TexConstant.Lines = {
        NONE: 'none',
        SOLID: 'solid',
        DASHED: 'dashed'
    };
    TexConstant.Side = {
        LEFT: 'left',
        RIGHT: 'right',
        LEFTOVERLAP: 'leftoverlap',
        RIGHTOVERLAP: 'rightoverlap'
    };
    TexConstant.Width = {
        AUTO: 'auto',
        FIT: 'fit'
    };
    TexConstant.Actiontype = {
        TOGGLE: 'toggle',
        STATUSLINE: 'statusline',
        TOOLTIP: 'tooltip',
        INPUT: 'input'
    };
    TexConstant.Length = {
        VERYVERYTHINMATHSPACE: 'veryverythinmathspace',
        VERYTHINMATHSPACE: 'verythinmathspace',
        THINMATHSPACE: 'thinmathspace',
        MEDIUMMATHSPACE: 'mediummathspace',
        THICKMATHSPACE: 'thickmathspace',
        VERYTHICKMATHSPACE: 'verythickmathspace',
        VERYVERYTHICKMATHSPACE: 'veryverythickmathspace',
        NEGATIVEVERYVERYTHINMATHSPACE: 'negativeveryverythinmathspace',
        NEGATIVEVERYTHINMATHSPACE: 'negativeverythinmathspace',
        NEGATIVETHINMATHSPACE: 'negativethinmathspace',
        NEGATIVEMEDIUMMATHSPACE: 'negativemediummathspace',
        NEGATIVETHICKMATHSPACE: 'negativethickmathspace',
        NEGATIVEVERYTHICKMATHSPACE: 'negativeverythickmathspace',
        NEGATIVEVERYVERYTHICKMATHSPACE: 'negativeveryverythickmathspace'
    };
    TexConstant.Overflow = {
        LINBREAK: 'linebreak',
        SCROLL: 'scroll',
        ELIDE: 'elide',
        TRUNCATE: 'truncate',
        SCALE: 'scale'
    };
    TexConstant.Unit = {
        EM: 'em',
        EX: 'ex',
        PX: 'px',
        IN: 'in',
        CM: 'cm',
        MM: 'mm',
        PT: 'pt',
        PC: 'pc'
    };
    TexConstant.TexClass = {
        ORD: 0,
        OP: 1,
        BIN: 2,
        REL: 3,
        OPEN: 4,
        CLOSE: 5,
        PUNCT: 6,
        INNER: 7,
        VCENTER: 8,
        NONE: -1
    };
    TexConstant.TexClassNames = [
        'ORD',
        'OP',
        'BIN',
        'REL',
        'OPEN',
        'CLOSE',
        'PUNCT',
        'INNER',
        'VCENTER'
    ];
})(TexConstant = exports.TexConstant || (exports.TexConstant = {}));
//# sourceMappingURL=TexConstants.js.map