"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var pattern = /%(\d+|\{\d+\}|\{[a-z]+:\%\d+(?:\|(?:%\{\d+\}|%.|[^\}])*)+\}|.)/g;
var TexError = (function () {
    function TexError(input) {
        if (!(input.length > 1)) {
            this.message = '';
            return;
        }
        this.id = input[0];
        this.message = TexError.processString(input[1], input.slice(2));
    }
    TexError.processString = function (str, args) {
        var parts = str.split(pattern);
        for (var i = 1, m = parts.length; i < m; i += 2) {
            var c = parts[i].charAt(0);
            if (c >= '0' && c <= '9') {
                parts[i] = args[parseInt(parts[i], 10) - 1];
                if (typeof parts[i] === 'number') {
                    parts[i] = parts[i].toString();
                }
            }
            else if (c === '{') {
                c = parts[i].substr(1);
                if (c >= '0' && c <= '9') {
                    parts[i] = args[parseInt(parts[i].substr(1, parts[i].length - 2), 10) - 1];
                    if (typeof parts[i] === 'number')
                        parts[i] = parts[i].toString();
                }
                else {
                    var match = parts[i].match(/^\{([a-z]+):%(\d+)\|(.*)\}$/);
                    if (match) {
                        parts[i] = '%' + parts[i];
                    }
                }
            }
            if (parts[i] == null) {
                parts[i] = '???';
            }
        }
        return parts.join('');
    };
    return TexError;
}());
exports.default = TexError;
//# sourceMappingURL=TexError.js.map