"use strict";
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var sm = require("./SymbolMap.js");
var MapHandler_js_1 = require("./MapHandler.js");
var BaseMappings_js_1 = require("./BaseMappings.js");
var AmsMappings_js_1 = require("./AmsMappings.js");
var AmsSymbols_js_1 = require("./AmsSymbols.js");
var ParseMethods_js_1 = require("./ParseMethods.js");
var TexParser = (function () {
    function TexParser() {
        this.input = '';
        this.remainder = '';
        this.macroCount = 0;
        this.configurations = new Map();
        this.configure(BaseMappings_js_1.BaseMappings.CONFIGURATION);
        this.append(AmsMappings_js_1.AmsMappings.CONFIGURATION);
        this.append(AmsSymbols_js_1.AmsSymbols.CONFIGURATION);
        this.setup(ParseMethods_js_1.ParseMethods);
    }
    TexParser.prototype.process = function (tex) { };
    TexParser.prototype.setup = function (env) {
        var maps = MapHandler_js_1.default.getInstance().allMaps();
        for (var i = 0, map = void 0; map = maps[i]; i++) {
            if (map instanceof sm.CharacterMap ||
                map instanceof sm.RegExpMap ||
                map instanceof sm.EnvironmentMap) {
                try {
                    var parser = map.parser(null);
                    if (typeof parser === 'string') {
                        map.parser = env[parser];
                    }
                }
                catch (e) { }
            }
            if (map instanceof sm.MacroMap) {
                map.functionMap = env;
            }
        }
        this.fallback('character', env['Other']);
        this.fallback('macro', env['csUndefined']);
        this.fallback('environment', env['envUndefined']);
    };
    TexParser.prototype.configure = function (config) {
        for (var key in config) {
            var name_1 = key;
            this.configurations.set(name_1, new SubHandler(config[name_1] || []));
        }
    };
    TexParser.prototype.append = function (config) {
        for (var key in config) {
            var name_2 = key;
            try {
                for (var _a = __values(config[name_2]), _b = _a.next(); !_b.done; _b = _a.next()) {
                    var map = _b.value;
                    this.configurations.get(name_2).add(map);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                }
                finally { if (e_1) throw e_1.error; }
            }
        }
        var e_1, _c;
    };
    TexParser.prototype.parse = function (kind, input) {
        return this.configurations.get(kind).parse(input);
    };
    TexParser.prototype.lookup = function (kind, symbol) {
        return this.configurations.get(kind).lookup(symbol);
    };
    TexParser.prototype.fallback = function (kind, method) {
        return this.configurations.get(kind).fallback(method);
    };
    TexParser.prototype.contains = function (kind, symbol) {
        return this.configurations.get(kind).contains(symbol);
    };
    TexParser.prototype.toString = function () {
        var str = '';
        try {
            for (var _a = __values(Array.from(this.configurations.keys())), _b = _a.next(); !_b.done; _b = _a.next()) {
                var config = _b.value;
                str += config + ': ' +
                    this.configurations.get(config) + '\n';
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_2) throw e_2.error; }
        }
        return str;
        var e_2, _c;
    };
    return TexParser;
}());
exports.default = TexParser;
var SubHandler = (function () {
    function SubHandler(maps) {
        this._configuration = [];
        this._fallback = (function (x) { return null; });
        try {
            for (var maps_1 = __values(maps), maps_1_1 = maps_1.next(); !maps_1_1.done; maps_1_1 = maps_1.next()) {
                var name_3 = maps_1_1.value;
                this.add(name_3);
            }
        }
        catch (e_3_1) { e_3 = { error: e_3_1 }; }
        finally {
            try {
                if (maps_1_1 && !maps_1_1.done && (_a = maps_1.return)) _a.call(maps_1);
            }
            finally { if (e_3) throw e_3.error; }
        }
        var e_3, _a;
    }
    SubHandler.prototype.fallback = function (method) {
        this._fallback = method;
    };
    SubHandler.prototype.add = function (name) {
        var map = MapHandler_js_1.default.getInstance().getMap(name);
        if (!map) {
            this.warn('Configuration ' + name + ' not found! Omitted.');
            return;
        }
        this._configuration.push(map);
    };
    SubHandler.prototype.parse = function (input) {
        try {
            for (var _a = __values(this._configuration), _b = _a.next(); !_b.done; _b = _a.next()) {
                var map = _b.value;
                var result = map.parse(input);
                if (result) {
                    return result;
                }
            }
        }
        catch (e_4_1) { e_4 = { error: e_4_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_4) throw e_4.error; }
        }
        var _d = __read(input, 2), symbol = _d[0], env = _d[1];
        return this._fallback.bind(env)(env, symbol);
        var e_4, _c;
    };
    SubHandler.prototype.lookup = function (symbol) {
        var map = this.applicable(symbol);
        return map ? map.lookup(symbol) : null;
    };
    SubHandler.prototype.contains = function (symbol) {
        return this.applicable(symbol) ? true : false;
    };
    SubHandler.prototype.toString = function () {
        return this._configuration
            .map(function (x) { return x.name; })
            .join(', ');
    };
    SubHandler.prototype.applicable = function (symbol) {
        try {
            for (var _a = __values(this._configuration), _b = _a.next(); !_b.done; _b = _a.next()) {
                var map = _b.value;
                if (map.contains(symbol)) {
                    return map;
                }
            }
        }
        catch (e_5_1) { e_5 = { error: e_5_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_5) throw e_5.error; }
        }
        return null;
        var e_5, _c;
    };
    SubHandler.prototype.warn = function (message) {
        console.log('TexParser Warning: ' + message);
    };
    return SubHandler;
}());
//# sourceMappingURL=TexParser.js.map