import { TextNode, MmlNode } from '../../core/MmlTree/MmlNode.js';
import { Property, PropertyList } from '../../core/Tree/Node.js';
import { Args } from './Types.js';
export declare namespace TreeHelper {
    function createNode(kind: string, children: MmlNode[], def: any, text?: TextNode): MmlNode;
    function createText(text: string): TextNode;
    function createEntity(code: string): TextNode;
    function createError(message: string): MmlNode;
    function createMath(math: MmlNode): MmlNode;
    function getRoot(tree: MmlNode): MmlNode;
    function getChildren(node: MmlNode): (MmlNode | TextNode)[];
    function getText(node: TextNode): string;
    function appendChildren(node: MmlNode, children: (MmlNode | TextNode)[]): void;
    function setAttribute(node: MmlNode, attribute: string, value: Args): void;
    function setProperties(node: MmlNode, properties: PropertyList): void;
    function getProperty(node: MmlNode, property: string): Property;
    function getAttribute(node: MmlNode, attr: string): Property;
    function getChildAt(node: MmlNode, position: number): MmlNode | TextNode;
    function setData(node: MmlNode, position: number, child: MmlNode): void;
    function copyChildren(oldNode: MmlNode, newNode: MmlNode): void;
    function copyAttributes(oldNode: MmlNode, newNode: MmlNode): void;
    function isType(node: MmlNode, kind: string): boolean;
    function isEmbellished(node: MmlNode): boolean;
    function getTexClass(node: MmlNode): number;
    function getCore(node: MmlNode): MmlNode;
    function getCoreMO(node: MmlNode): MmlNode;
    function cleanSubSup(node: MmlNode): MmlNode;
    function printSimple(txt: string): void;
    function untested(kind: string | number): void;
    function printMethod(text: string): void;
    function printJSON(node: MmlNode): void;
    function printDef(def: PropertyList): void;
    function isNode(item: Node): boolean;
    function isInferred(node: MmlNode): boolean;
}
