import { AbstractOutputJax } from '../core/OutputJax.js';
import { OptionList } from '../util/Options.js';
import { MathDocument } from '../core/MathDocument.js';
import { MathItem } from '../core/MathItem.js';
import { MmlNode } from '../core/MmlTree/MmlNode.js';
import { HTMLNodes } from '../util/HTMLNodes.js';
import { CHTMLWrapper } from './chtml/Wrapper.js';
import { CHTMLWrapperFactory } from './chtml/WrapperFactory.js';
import { FontData } from './chtml/FontData.js';
import { CssStyles } from './chtml/CssStyles.js';
import { BBox } from './chtml/BBox.js';
export declare class CHTML extends AbstractOutputJax {
    static NAME: string;
    static OPTIONS: OptionList;
    nodes: HTMLNodes;
    factory: CHTMLWrapperFactory;
    font: FontData;
    cssStyles: CssStyles;
    document: MathDocument;
    math: MathItem;
    nodeMap: Map<MmlNode, CHTMLWrapper>;
    constructor(options?: OptionList);
    typeset(math: MathItem, html: MathDocument): HTMLElement;
    getBBox(math: MathItem, html: MathDocument): BBox;
    escaped(math: MathItem, html: MathDocument): HTMLElement;
    getMetrics(html: MathDocument): void;
    styleSheet(html: MathDocument): HTMLStyleElement;
    toCHTML(node: MmlNode, parent: HTMLElement): void;
    html(type: string, def?: OptionList, content?: Node[]): HTMLElement;
    text(text: string): Text;
}
