"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
Object.defineProperty(exports, "__esModule", { value: true });
var OutputJax_js_1 = require("../core/OutputJax.js");
var Options_js_1 = require("../util/Options.js");
var HTMLNodes_js_1 = require("../util/HTMLNodes.js");
var WrapperFactory_js_1 = require("./chtml/WrapperFactory.js");
var tex_js_1 = require("./chtml/fonts/tex.js");
var CssStyles_js_1 = require("./chtml/CssStyles.js");
var lengths_js_1 = require("../util/lengths.js");
var CHTML = (function (_super) {
    __extends(CHTML, _super);
    function CHTML(options) {
        if (options === void 0) { options = null; }
        var _this = this;
        var _a = __read(Options_js_1.separateOptions(options, tex_js_1.TeXFont.OPTIONS), 2), chtmlOptions = _a[0], fontOptions = _a[1];
        _this = _super.call(this, chtmlOptions) || this;
        _this.factory = _this.options.CHTMLWrapperFactory || new WrapperFactory_js_1.CHTMLWrapperFactory();
        _this.factory.chtml = _this;
        _this.nodes = new HTMLNodes_js_1.HTMLNodes();
        _this.cssStyles = _this.options.cssStyles || new CssStyles_js_1.CssStyles();
        _this.font = _this.options.font || new tex_js_1.TeXFont(fontOptions);
        return _this;
    }
    CHTML.prototype.typeset = function (math, html) {
        this.document = html;
        this.math = math;
        this.nodes.document = html.document;
        math.root.setTeXclass(null);
        var node = this.html('mjx-chtml', { 'class': 'MathJax MJX-CHTML MJX-TEX' });
        var scale = math.metrics.scale * this.options.scale;
        if (scale !== 1) {
            node.style.fontSize = lengths_js_1.percent(scale);
        }
        this.nodeMap = new Map();
        this.toCHTML(math.root, node);
        this.nodeMap = null;
        return node;
    };
    CHTML.prototype.getBBox = function (math, html) {
        this.document = html;
        this.math = math;
        this.nodes.document = html.document;
        math.root.setTeXclass(null);
        this.nodeMap = new Map();
        var bbox = this.factory.wrap(math.root).getBBox();
        this.nodeMap = null;
        return bbox;
    };
    CHTML.prototype.escaped = function (math, html) {
        this.nodes.document = html.document;
        return this.html('span', {}, [this.text(math.math)]);
    };
    CHTML.prototype.getMetrics = function (html) {
        try {
            for (var _a = __values(html.math), _b = _a.next(); !_b.done; _b = _a.next()) {
                var math = _b.value;
                math.setMetrics(16, 8, 1000000, 1000000, 1);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_1) throw e_1.error; }
        }
        var e_1, _c;
    };
    CHTML.prototype.styleSheet = function (html) {
        try {
            for (var _a = __values(this.factory.getKinds()), _b = _a.next(); !_b.done; _b = _a.next()) {
                var kind = _b.value;
                var CLASS = this.factory.getNodeClass(kind);
                if (CLASS.autoStyle && kind !== 'unknown') {
                    this.cssStyles.addStyles((_c = {}, _c['mjx-' + CLASS.kind] = { display: 'inline-block' }, _c));
                }
                this.cssStyles.addStyles(CLASS.styles);
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_d = _a.return)) _d.call(_a);
            }
            finally { if (e_2) throw e_2.error; }
        }
        this.cssStyles.addStyles(this.font.styles);
        var sheet = this.html('style');
        sheet.id = 'CHTML-styles';
        sheet.innerHTML = '\n' + this.cssStyles.cssText + '\n';
        return sheet;
        var e_2, _d, _c;
    };
    CHTML.prototype.toCHTML = function (node, parent) {
        return this.factory.wrap(node).toCHTML(parent);
    };
    CHTML.prototype.html = function (type, def, content) {
        if (def === void 0) { def = {}; }
        if (content === void 0) { content = []; }
        return this.nodes.node(type, def, content);
    };
    CHTML.prototype.text = function (text) {
        return this.nodes.text(text);
    };
    return CHTML;
}(OutputJax_js_1.AbstractOutputJax));
CHTML.NAME = 'CHTML';
CHTML.OPTIONS = __assign({}, OutputJax_js_1.AbstractOutputJax.OPTIONS, { scale: 1, skipAttributes: {}, CHTMLWrapperFactory: null, font: null, cssStyles: null });
exports.CHTML = CHTML;
//# sourceMappingURL=chtml.js.map