"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var Wrapper_js_1 = require("../Wrapper.js");
var mfrac_js_1 = require("../../../core/MmlTree/MmlNodes/mfrac.js");
var CHTMLmfrac = (function (_super) {
    __extends(CHTMLmfrac, _super);
    function CHTMLmfrac() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CHTMLmfrac.prototype.toCHTML = function (parent) {
        this.chtml = this.standardCHTMLnode(parent);
        var attr = this.node.attributes.getList('displaystyle', 'scriptlevel');
        var style = (attr.displaystyle && attr.scriptlevel === 0 ? { type: 'd' } : {});
        var fstyle = (this.node.getProperty('withDelims') ? __assign({}, style, { delims: 'true' }) : style);
        var num, den;
        this.chtml.appendChild(this.html('mjx-frac', fstyle, [
            num = this.html('mjx-num', {}, [this.html('mjx-nstrut', style)]),
            this.html('mjx-dbox', {}, [
                this.html('mjx-dtable', {}, [
                    this.html('mjx-line', style),
                    this.html('mjx-row', {}, [
                        den = this.html('mjx-den', {}, [this.html('mjx-dstrut', style)])
                    ])
                ])
            ])
        ]));
        this.childNodes[0].toCHTML(num);
        this.childNodes[1].toCHTML(den);
    };
    CHTMLmfrac.prototype.computeBBox = function (bbox) {
        bbox.empty();
        var attr = this.node.attributes.getList('displaystyle', 'scriptlevel');
        var display = attr.displaystyle && attr.scriptlevel === 0;
        var nbox = this.childNodes[0].getBBox();
        var dbox = this.childNodes[1].getBBox();
        var pad = (this.node.getProperty('withDelims') ? 0 : this.font.params.nulldelimiterspace);
        var a = this.font.params.axis_height;
        var T = (display ? 3.5 : 1.5) * this.font.params.rule_thickness;
        bbox.combine(nbox, 0, a + T + Math.max(nbox.d * nbox.rscale, display ? .217 : .054));
        bbox.combine(dbox, 0, a - T - Math.max(dbox.h * dbox.rscale, display ? .726 : .505));
        bbox.w += 2 * pad + .2;
        bbox.clean();
    };
    CHTMLmfrac.prototype.canStretch = function (direction) {
        return false;
    };
    return CHTMLmfrac;
}(Wrapper_js_1.CHTMLWrapper));
CHTMLmfrac.kind = mfrac_js_1.MmlMfrac.prototype.kind;
CHTMLmfrac.styles = {
    'mjx-frac': {
        display: 'inline-block',
        'vertical-align': '0.17em',
        padding: '0 .22em'
    },
    'mjx-frac[type="d"]': {
        'vertical-align': '.04em'
    },
    'mjx-frac[delims="true"]': {
        padding: '0 .1em'
    },
    'mjx-dtable': {
        display: 'inline-table',
        width: '100%'
    },
    'mjx-dtable > *': {
        'font-size': '2000%'
    },
    'mjx-dbox': {
        display: 'block',
        'font-size': '5%'
    },
    'mjx-row': {
        display: 'table-row'
    },
    'mjx-num': {
        display: 'block',
        'text-align': 'center'
    },
    'mjx-den': {
        display: 'block',
        'text-align': 'center'
    },
    'mjx-den[align="right"], mjx-num[align="right"]': {
        align: 'right'
    },
    'mjx-den[align="left"], mjx-num[align="left"]': {
        align: 'left'
    },
    'mjx-nstrut': {
        display: 'inline-block',
        height: '.054em',
        width: 0,
        'vertical-align': '-.054em'
    },
    'mjx-nstrut[type="d"]': {
        height: '.217em',
        'vertical-align': '-.217em',
    },
    'mjx-dstrut': {
        display: 'inline-block',
        height: '.505em',
        width: 0
    },
    'mjx-dstrut[type="d"]': {
        height: '.726em',
    },
    'mjx-line': {
        display: 'block',
        'box-sizing': 'border-box',
        'min-height': '1px',
        height: '.06em',
        'border-top': '.06em solid',
        margin: '.06em -.1em',
        overflow: 'hidden'
    },
    'mjx-line[type="d"]': {
        margin: '.18em -.1em'
    }
};
exports.CHTMLmfrac = CHTMLmfrac;
//# sourceMappingURL=mfrac.js.map