"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var Wrapper_js_1 = require("../Wrapper.js");
var mo_js_1 = require("../../../core/MmlTree/MmlNodes/mo.js");
var FontData_js_1 = require("../FontData.js");
var DirectionVH = (_a = {},
    _a[1] = 'v',
    _a[2] = 'h',
    _a);
var CHTMLmo = (function (_super) {
    __extends(CHTMLmo, _super);
    function CHTMLmo() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.noIC = false;
        _this.size = null;
        return _this;
    }
    CHTMLmo.prototype.toCHTML = function (parent) {
        var attributes = this.node.attributes;
        var symmetric = attributes.get('symmetric') && this.stretch.dir !== 2;
        var stretchy = this.stretch.dir !== 0;
        if (stretchy && this.size === null) {
            this.getStretchedVariant([]);
        }
        var chtml = this.standardCHTMLnode(parent);
        if (this.noIC) {
            chtml.setAttribute('noIC', 'true');
        }
        if (stretchy && this.size < 0) {
            this.stretchHTML(chtml, symmetric);
        }
        else {
            if (symmetric || attributes.get('largeop')) {
                chtml = chtml.appendChild(this.html('mjx-symmetric'));
            }
            try {
                for (var _a = __values(this.childNodes), _b = _a.next(); !_b.done; _b = _a.next()) {
                    var child = _b.value;
                    child.toCHTML(chtml);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                }
                finally { if (e_1) throw e_1.error; }
            }
        }
        var e_1, _c;
    };
    CHTMLmo.prototype.stretchHTML = function (chtml, symmetric) {
        var c = this.getText().charCodeAt(0);
        var delim = this.stretch;
        var stretch = delim.stretch;
        var content = [];
        if (stretch[0]) {
            content.push(this.html('mjx-beg', {}, [this.html('mjx-c')]));
        }
        content.push(this.html('mjx-ext', {}, [this.html('mjx-c')]));
        if (stretch.length === 4) {
            content.push(this.html('mjx-mid', {}, [this.html('mjx-c')]), this.html('mjx-ext', {}, [this.html('mjx-c')]));
        }
        if (stretch[2]) {
            content.push(this.html('mjx-end', {}, [this.html('mjx-c')]));
        }
        var styles = {};
        var _a = this.bbox, h = _a.h, d = _a.d, w = _a.w;
        if (delim.dir === 1) {
            content.push(this.html('mjx-mark'));
            styles.height = this.em(h + d);
            styles.verticalAlign = this.em(-d);
        }
        else {
            styles.width = this.em(w);
        }
        var dir = DirectionVH[delim.dir];
        var properties = { c: this.char(delim.c || c), style: styles };
        var html = this.html('mjx-stretchy-' + dir, properties, content);
        chtml.appendChild(html);
    };
    CHTMLmo.prototype.computeBBox = function (bbox) {
        var stretchy = (this.stretch.dir !== 0);
        if (stretchy && this.size === null) {
            this.getStretchedVariant([0]);
        }
        if (stretchy && this.size < 0)
            return;
        _super.prototype.computeBBox.call(this, bbox);
        var child = this.childNodes[this.childNodes.length - 1];
        if (child && child.bbox.ic) {
            bbox.ic = child.bbox.ic;
            if (!this.noIC)
                bbox.w += bbox.ic;
        }
        if (this.node.attributes.get('symmetric') && this.stretch.dir !== 2) {
            var d = ((bbox.h + bbox.d) / 2 + this.font.params.axis_height) - bbox.h;
            bbox.h += d;
            bbox.d += d;
        }
    };
    CHTMLmo.prototype.getVariant = function () {
        if (this.node.attributes.get('largeop')) {
            this.variant = (this.node.attributes.get('displaystyle') ? '-largeop' : '-smallop');
        }
        else {
            _super.prototype.getVariant.call(this);
        }
    };
    CHTMLmo.prototype.canStretch = function (direction) {
        var attributes = this.node.attributes;
        if (!attributes.get('stretchy'))
            return false;
        var c = this.getText();
        if (c.length !== 1)
            return false;
        var delim = this.font.getDelimiter(c.charCodeAt(0));
        this.stretch = (delim && delim.dir === direction ? delim : FontData_js_1.NOSTRETCH);
        return this.stretch.dir !== 0;
    };
    CHTMLmo.prototype.getStretchedVariant = function (WH, exact) {
        if (exact === void 0) { exact = false; }
        if (this.stretch.dir !== 0) {
            var D = this.getWH(WH);
            var min = this.getSize('minsize', 0);
            var max = this.getSize('maxsize', Infinity);
            D = Math.max(min, Math.min(max, D));
            var m = (min || exact ? D : Math.max(D * this.font.params.delimiterfactor / 1000, D - this.font.params.delimitershortfall));
            var delim = this.stretch;
            var c = delim.c || this.getText().charCodeAt(0);
            var i = 0;
            if (delim.sizes) {
                try {
                    for (var _a = __values(delim.sizes), _b = _a.next(); !_b.done; _b = _a.next()) {
                        var d = _b.value;
                        if (d >= m) {
                            this.variant = this.font.getSizeVariant(c, i);
                            this.size = i;
                            return;
                        }
                        i++;
                    }
                }
                catch (e_2_1) { e_2 = { error: e_2_1 }; }
                finally {
                    try {
                        if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                    }
                    finally { if (e_2) throw e_2.error; }
                }
            }
            if (delim.stretch) {
                this.size = -1;
                this.getStretchBBox(WH, D, delim);
            }
            else {
                this.variant = this.font.getSizeVariant(c, i - 1);
                this.size = i - 1;
            }
        }
        var e_2, _c;
    };
    CHTMLmo.prototype.getSize = function (name, value) {
        var attributes = this.node.attributes;
        if (attributes.isSet(name)) {
            value = this.length2em(attributes.get(name), 1, 1);
        }
        return value;
    };
    CHTMLmo.prototype.getWH = function (WH) {
        if (WH.length === 0)
            return 0;
        if (WH.length === 1)
            return WH[0];
        var _a = __read(WH, 2), H = _a[0], D = _a[1];
        var a = this.font.params.axis_height;
        return (this.node.attributes.get('symmetric') ? 2 * Math.max(H - a, D + a) : H + D);
    };
    CHTMLmo.prototype.getStretchBBox = function (WHD, D, C) {
        var _a = __read(C.HDW, 3), h = _a[0], d = _a[1], w = _a[2];
        if (this.stretch.dir === 1) {
            _b = __read(this.getBaseline(WHD, D, C), 2), h = _b[0], d = _b[1];
        }
        else {
            w = D;
        }
        this.bbox.h = h;
        this.bbox.d = d;
        this.bbox.w = w;
        var _b;
    };
    CHTMLmo.prototype.getBaseline = function (WHD, HD, C) {
        var hasWHD = (WHD.length === 2 && WHD[0] + WHD[1] === HD);
        var symmetric = this.node.attributes.get('symmetric');
        var _a = __read((hasWHD ? WHD : [HD, 0]), 2), H = _a[0], D = _a[1];
        var _b = __read([H + D, 0], 2), h = _b[0], d = _b[1];
        if (symmetric) {
            var a = this.font.params.axis_height;
            if (hasWHD)
                h = 2 * Math.max(H - a, D + a);
            d = h / 2 - a;
        }
        else if (hasWHD) {
            d = D;
        }
        else {
            var _c = __read((C.HDW || [.75, .25]), 2), ch = _c[0], cd = _c[1];
            d = cd * (h / (ch + cd));
        }
        return [h - d, d];
    };
    return CHTMLmo;
}(Wrapper_js_1.CHTMLWrapper));
CHTMLmo.kind = mo_js_1.MmlMo.prototype.kind;
CHTMLmo.styles = {
    'mjx-symmetric': {
        'vertical-align': '.25em'
    },
    'mjx-symmetric > mjx-c': {
        'vertical-align': 'middle'
    },
    'mjx-stretchy-h': {
        display: 'inline-table',
        width: '100%',
        'min-width': '1.2em'
    },
    'mjx-stretchy-h > mjx-beg, mjx-stretchy-h > mjx-end': {
        display: 'table-cell',
        width: 0
    },
    'mjx-stretchy-h > mjx-ext': {
        display: 'table-cell',
        overflow: 'hidden',
        width: '100%'
    },
    'mjx-stretchy-h > mjx-ext > mjx-c': {
        transform: 'scalex(500)'
    },
    'mjx-stretchy-h > mjx-beg > mjx-c': {
        'margin-right': '-.1em'
    },
    'mjx-stretchy-h > mjx-end > mjx-c': {
        'margin-left': '-.1em'
    },
    'mjx-stretchy-v': {
        display: 'inline-block'
    },
    'mjx-stretchy-v > *': {
        display: 'block'
    },
    'mjx-stretchy-v > mjx-beg': {
        height: 0
    },
    'mjx-stretchy-v > mjx-end > mjx-c': {
        display: 'block'
    },
    'mjx-stretchy-v > * > mjx-c': {
        transform: 'scale(1)',
        'transform-origin': 'left center',
        overflow: 'hidden'
    },
    'mjx-stretchy-v > mjx-ext': {
        display: 'block',
        height: '100%',
        'box-sizing': 'border-box',
        border: '0px solid transparent',
        overflow: 'hidden'
    },
    'mjx-stretchy-v > mjx-ext > mjx-c': {
        transform: 'scaleY(500) translateY(.1em)',
        overflow: 'visible'
    },
    'mjx-mark': {
        display: 'inline-block',
        height: '0px'
    }
};
exports.CHTMLmo = CHTMLmo;
var _a;
//# sourceMappingURL=mo.js.map