"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
Object.defineProperty(exports, "__esModule", { value: true });
var Wrapper_js_1 = require("../Wrapper.js");
var mpadded_js_1 = require("../../../core/MmlTree/MmlNodes/mpadded.js");
var CHTMLmpadded = (function (_super) {
    __extends(CHTMLmpadded, _super);
    function CHTMLmpadded() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CHTMLmpadded.prototype.toCHTML = function (parent) {
        var chtml = this.standardCHTMLnode(parent);
        var content = [];
        var style = {};
        var _a = __read(this.getDimens(), 8), H = _a[0], D = _a[1], W = _a[2], dh = _a[3], dd = _a[4], dw = _a[5], x = _a[6], y = _a[7];
        if (dw) {
            style.width = this.em(W + dw);
        }
        if (dh || dd) {
            style.margin = this.em(dh) + ' 0 ' + this.em(dd);
        }
        if (x || y) {
            style.position = 'relative';
            content.push(this.html('mjx-rbox', { style: { left: this.em(x), top: this.em(-y) } }));
        }
        chtml = chtml.appendChild(this.html('mjx-block', { style: style }, content));
        try {
            for (var _b = __values(this.childNodes), _c = _b.next(); !_c.done; _c = _b.next()) {
                var child = _c.value;
                child.toCHTML(chtml.firstChild || chtml);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_d = _b.return)) _d.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
        var e_1, _d;
    };
    CHTMLmpadded.prototype.getDimens = function () {
        var values = this.node.attributes.getList('width', 'height', 'depth', 'lspace', 'voffset');
        var bbox = this.childNodes[0].getBBox();
        var w = bbox.w, h = bbox.h, d = bbox.d;
        var W = w, H = h, D = d, x = 0, y = 0;
        if (values.width !== '')
            w = this.dimen(values.width, bbox, 'w', 0);
        if (values.height !== '')
            h = this.dimen(values.height, bbox, 'h', 0);
        if (values.depth !== '')
            d = this.dimen(values.depth, bbox, 'd', 0);
        if (values.voffset !== '')
            y = this.dimen(values.voffset, bbox);
        if (values.lspace !== '')
            x = this.dimen(values.lspace, bbox);
        return [H, D, W, h - H, d - D, w - W, x, y];
    };
    CHTMLmpadded.prototype.dimen = function (length, bbox, d, m) {
        if (d === void 0) { d = ''; }
        if (m === void 0) { m = null; }
        length = String(length);
        var match = length.match(/width|height|depth/);
        var size = (match ? bbox[match[0].charAt(0)] : (d ? bbox[d] : 0));
        var dimen = (this.length2em(length, size) || 0);
        if (length.match(/^[-+]/) && d) {
            dimen += size;
        }
        if (m != null) {
            dimen = Math.max(m, dimen);
        }
        return dimen;
    };
    CHTMLmpadded.prototype.computeBBox = function (bbox) {
        var _a = __read(this.getDimens(), 8), H = _a[0], D = _a[1], W = _a[2], dh = _a[3], dd = _a[4], dw = _a[5], x = _a[6], y = _a[7];
        bbox.w = W + dw;
        bbox.h = H + dh;
        bbox.d = D + dd;
    };
    return CHTMLmpadded;
}(Wrapper_js_1.CHTMLWrapper));
CHTMLmpadded.kind = mpadded_js_1.MmlMpadded.prototype.kind;
CHTMLmpadded.styles = {
    'mjx-mpadded': {
        display: 'inline-block'
    },
    'mjx-rbox': {
        display: 'inline-block',
        position: 'relative'
    }
};
exports.CHTMLmpadded = CHTMLmpadded;
//# sourceMappingURL=mpadded.js.map