"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
Object.defineProperty(exports, "__esModule", { value: true });
var Wrapper_js_1 = require("../Wrapper.js");
var mrow_js_1 = require("../../../core/MmlTree/MmlNodes/mrow.js");
var CHTMLmrow = (function (_super) {
    __extends(CHTMLmrow, _super);
    function CHTMLmrow(factory, node, parent) {
        if (parent === void 0) { parent = null; }
        var _this = _super.call(this, factory, node, parent) || this;
        _this.stretchChildren();
        return _this;
    }
    CHTMLmrow.prototype.toCHTML = function (parent) {
        var chtml = this.chtml = parent;
        if (!this.node.isInferred) {
            chtml = this.standardCHTMLnode(parent);
        }
        var hasNegative = false;
        try {
            for (var _a = __values(this.childNodes), _b = _a.next(); !_b.done; _b = _a.next()) {
                var child = _b.value;
                child.toCHTML(chtml);
                if (child.bbox.w < 0) {
                    hasNegative = true;
                }
                if (child.bbox.pwidth) {
                    this.makeFullWidth();
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_1) throw e_1.error; }
        }
        if (hasNegative) {
            var w = this.getBBox().w;
            if (w)
                chtml.style.width = this.em(Math.max(0, w));
            if (w < 0)
                chtml.style.marginRight = this.em(w);
        }
        var e_1, _c;
    };
    CHTMLmrow.prototype.makeFullWidth = function () {
        this.bbox.pwidth = '100%';
        this.chtml.setAttribute('width', 'full');
    };
    CHTMLmrow.prototype.stretchChildren = function () {
        var stretchy = [];
        try {
            for (var _a = __values(this.childNodes), _b = _a.next(); !_b.done; _b = _a.next()) {
                var child = _b.value;
                if (child.canStretch(1)) {
                    stretchy.push(child);
                }
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_2) throw e_2.error; }
        }
        var count = stretchy.length;
        var nodeCount = this.childNodes.length;
        if (count && nodeCount > 1) {
            var H = 0, D = 0;
            var all = (count > 1 && count === nodeCount);
            try {
                for (var _d = __values(this.childNodes), _e = _d.next(); !_e.done; _e = _d.next()) {
                    var child = _e.value;
                    var noStretch = (child.stretch.dir === 0);
                    if (all || noStretch) {
                        var _f = child.getBBox(noStretch), h = _f.h, d = _f.d;
                        if (h > H)
                            H = h;
                        if (d > D)
                            D = d;
                    }
                }
            }
            catch (e_3_1) { e_3 = { error: e_3_1 }; }
            finally {
                try {
                    if (_e && !_e.done && (_g = _d.return)) _g.call(_d);
                }
                finally { if (e_3) throw e_3.error; }
            }
            try {
                for (var stretchy_1 = __values(stretchy), stretchy_1_1 = stretchy_1.next(); !stretchy_1_1.done; stretchy_1_1 = stretchy_1.next()) {
                    var child = stretchy_1_1.value;
                    child.coreMO().getStretchedVariant([H, D]);
                }
            }
            catch (e_4_1) { e_4 = { error: e_4_1 }; }
            finally {
                try {
                    if (stretchy_1_1 && !stretchy_1_1.done && (_h = stretchy_1.return)) _h.call(stretchy_1);
                }
                finally { if (e_4) throw e_4.error; }
            }
        }
        var e_2, _c, e_3, _g, e_4, _h;
    };
    return CHTMLmrow;
}(Wrapper_js_1.CHTMLWrapper));
CHTMLmrow.kind = mrow_js_1.MmlMrow.prototype.kind;
exports.CHTMLmrow = CHTMLmrow;
var CHTMLinferredMrow = (function (_super) {
    __extends(CHTMLinferredMrow, _super);
    function CHTMLinferredMrow() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CHTMLinferredMrow.prototype.getScale = function () {
        this.bbox.scale = this.parent.bbox.scale;
        this.bbox.rscale = 1;
    };
    return CHTMLinferredMrow;
}(CHTMLmrow));
CHTMLinferredMrow.kind = mrow_js_1.MmlInferredMrow.prototype.kind;
exports.CHTMLinferredMrow = CHTMLinferredMrow;
//# sourceMappingURL=mrow.js.map