"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var Wrapper_js_1 = require("../Wrapper.js");
var BBox_js_1 = require("../BBox.js");
var msqrt_js_1 = require("../../../core/MmlTree/MmlNodes/msqrt.js");
var CHTMLmsqrt = (function (_super) {
    __extends(CHTMLmsqrt, _super);
    function CHTMLmsqrt(factory, node, parent) {
        if (parent === void 0) { parent = null; }
        var _this = _super.call(this, factory, node, parent) || this;
        var surd = _this.createMo('\u221A');
        surd.canStretch(1);
        var _a = _this.childNodes[_this.base].getBBox(), h = _a.h, d = _a.d;
        var t = _this.font.params.rule_thickness;
        var p = (_this.node.attributes.get('displaystyle') ? _this.font.params.x_height : t);
        _this.surdH = h + d + 2 * t + p / 4;
        surd.getStretchedVariant([_this.surdH - d, d], true);
        return _this;
    }
    Object.defineProperty(CHTMLmsqrt.prototype, "base", {
        get: function () {
            return 0;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CHTMLmsqrt.prototype, "surd", {
        get: function () {
            return 1;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CHTMLmsqrt.prototype, "root", {
        get: function () {
            return null;
        },
        enumerable: true,
        configurable: true
    });
    CHTMLmsqrt.prototype.createMo = function (text) {
        var mmlFactory = this.node.factory;
        var textNode = mmlFactory.create('text').setText(text);
        var mml = mmlFactory.create('mo', { stretchy: true }, [textNode]);
        var attributes = this.node.attributes;
        var display = attributes.get('display');
        var scriptlevel = attributes.get('scriptlevel');
        var defaults = {
            mathsize: ['math', attributes.get('mathsize')]
        };
        mml.setInheritedAttributes(defaults, display, scriptlevel, false);
        var node = this.wrap(mml);
        node.parent = this;
        this.childNodes.push(node);
        return node;
    };
    CHTMLmsqrt.prototype.toCHTML = function (parent) {
        var surd = this.childNodes[this.surd];
        var base = this.childNodes[this.base];
        var sbox = surd.getBBox();
        var bbox = base.getBBox();
        var _a = __read(this.getPQ(sbox), 2), p = _a[0], q = _a[1];
        var CHTML = this.standardCHTMLnode(parent);
        var SURD, BASE, ROOT, root;
        if (this.root != null) {
            ROOT = CHTML.appendChild(this.html('mjx-root'));
            root = this.childNodes[this.root];
        }
        var SQRT = CHTML.appendChild(this.html('mjx-sqrt', {}, [
            SURD = this.html('mjx-surd'),
            BASE = this.html('mjx-box', { style: { paddingTop: this.em(q) } })
        ]));
        this.addRoot(ROOT, root, sbox);
        surd.toCHTML(SURD);
        base.toCHTML(BASE);
        if (surd.size < 0) {
            SQRT.classList.add('mjx-tall');
        }
    };
    CHTMLmsqrt.prototype.addRoot = function (ROOT, root, sbox) {
    };
    CHTMLmsqrt.prototype.computeBBox = function (bbox) {
        var surdbox = this.childNodes[this.surd].getBBox();
        var basebox = new BBox_js_1.BBox(this.childNodes[this.base].getBBox());
        var _a = __read(this.getPQ(surdbox), 2), p = _a[0], q = _a[1];
        var _b = __read(this.getRootDimens(surdbox), 1), x = _b[0];
        var t = this.font.params.rule_thickness;
        var H = basebox.h + q + t;
        bbox.h = H + t;
        this.combineRootBBox(bbox, surdbox);
        bbox.combine(surdbox, x, H - surdbox.h);
        bbox.combine(basebox, x + surdbox.w, 0);
        bbox.clean();
    };
    CHTMLmsqrt.prototype.combineRootBBox = function (bbox, sbox) {
    };
    CHTMLmsqrt.prototype.getPQ = function (sbox) {
        var t = this.font.params.rule_thickness;
        var p = (this.node.attributes.get('displaystyle') ? this.font.params.x_height : t);
        var q = (sbox.h + sbox.d > this.surdH ? ((sbox.h + sbox.d) - (this.surdH - t)) / 2 : t + p / 4);
        return [p, q];
    };
    CHTMLmsqrt.prototype.getRootDimens = function (sbox) {
        return [0, 0, 0, 0];
    };
    return CHTMLmsqrt;
}(Wrapper_js_1.CHTMLWrapper));
CHTMLmsqrt.kind = msqrt_js_1.MmlMsqrt.prototype.kind;
CHTMLmsqrt.styles = {
    'mjx-root': {
        display: 'inline-block',
        'white-space': 'nowrap'
    },
    'mjx-surd': {
        display: 'inline-block',
        'vertical-align': 'top'
    },
    'mjx-sqrt': {
        display: 'inline-block',
        'padding-top': '.07em'
    },
    'mjx-sqrt > mjx-box': {
        'border-top': '.07em solid'
    },
    'mjx-sqrt.mjx-tall > mjx-box': {
        'padding-left': '.3em',
        'margin-left': '-.3em'
    }
};
exports.CHTMLmsqrt = CHTMLmsqrt;
//# sourceMappingURL=msqrt.js.map