"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var scriptbase_js_1 = require("./scriptbase.js");
var msubsup_js_1 = require("../../../core/MmlTree/MmlNodes/msubsup.js");
var CHTMLmsub = (function (_super) {
    __extends(CHTMLmsub, _super);
    function CHTMLmsub() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(CHTMLmsub.prototype, "script", {
        get: function () {
            return this.childNodes[this.node.sub];
        },
        enumerable: true,
        configurable: true
    });
    CHTMLmsub.prototype.getOffset = function (bbox, sbox) {
        return [0, -this.getV(bbox, sbox)];
    };
    return CHTMLmsub;
}(scriptbase_js_1.CHTMLscriptbase));
CHTMLmsub.kind = msubsup_js_1.MmlMsub.prototype.kind;
exports.CHTMLmsub = CHTMLmsub;
var CHTMLmsup = (function (_super) {
    __extends(CHTMLmsup, _super);
    function CHTMLmsup() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(CHTMLmsup.prototype, "script", {
        get: function () {
            return this.childNodes[this.node.sup];
        },
        enumerable: true,
        configurable: true
    });
    CHTMLmsup.prototype.getOffset = function (bbox, sbox) {
        var x = (this.baseCore.bbox.ic ? .2 * this.baseCore.bbox.ic + .05 : 0);
        return [x, this.getU(bbox, sbox)];
    };
    return CHTMLmsup;
}(scriptbase_js_1.CHTMLscriptbase));
CHTMLmsup.kind = msubsup_js_1.MmlMsup.prototype.kind;
CHTMLmsup.useIC = true;
exports.CHTMLmsup = CHTMLmsup;
var CHTMLmsubsup = (function (_super) {
    __extends(CHTMLmsubsup, _super);
    function CHTMLmsubsup() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.UVQ = null;
        return _this;
    }
    Object.defineProperty(CHTMLmsubsup.prototype, "subChild", {
        get: function () {
            return this.childNodes[this.node.sub];
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CHTMLmsubsup.prototype, "supChild", {
        get: function () {
            return this.childNodes[this.node.sup];
        },
        enumerable: true,
        configurable: true
    });
    CHTMLmsubsup.prototype.toCHTML = function (parent) {
        this.chtml = this.standardCHTMLnode(parent);
        var _a = __read(this.getUVQ(this.baseChild.getBBox(), this.subChild.getBBox(), this.supChild.getBBox()), 3), u = _a[0], v = _a[1], q = _a[2];
        var style = { 'vertical-align': this.em(v) };
        this.baseChild.toCHTML(this.chtml);
        var stack = this.chtml.appendChild(this.html('mjx-script', { style: style }));
        this.supChild.toCHTML(stack);
        stack.appendChild(this.html('mjx-spacer', { style: { 'margin-top': this.em(q) } }));
        this.subChild.toCHTML(stack);
        var corebox = this.baseCore.bbox;
        if (corebox.ic) {
            this.supChild.chtml.style.marginLeft = this.em((1.2 * corebox.ic + .05) / this.supChild.bbox.rscale);
        }
    };
    CHTMLmsubsup.prototype.computeBBox = function (bbox) {
        var basebox = this.baseChild.getBBox();
        var subbox = this.subChild.getBBox();
        var supbox = this.supChild.getBBox();
        bbox.empty();
        bbox.append(basebox);
        var w = bbox.w;
        var _a = __read(this.getUVQ(basebox, subbox, supbox), 3), u = _a[0], v = _a[1], q = _a[2];
        bbox.combine(subbox, w, v);
        bbox.combine(supbox, w, u);
        bbox.w += this.font.params.scriptspace;
        bbox.clean();
    };
    CHTMLmsubsup.prototype.getUVQ = function (basebox, subbox, supbox) {
        if (this.UVQ)
            return this.UVQ;
        var tex = this.font.params;
        var t = 3 * tex.rule_thickness;
        var subscriptshift = this.length2em(this.node.attributes.get('subscriptshift'), tex.sub2);
        var drop = (this.isCharBase() ? 0 : basebox.d + tex.sub_drop * subbox.rscale);
        var _a = __read([this.getU(basebox, supbox), Math.max(drop, subscriptshift)], 2), u = _a[0], v = _a[1];
        var q = (u - supbox.d * supbox.rscale) - (subbox.h * subbox.rscale - v);
        if (q < t) {
            v += t - q;
            var p = (4 / 5) * tex.x_height - (u - supbox.d * supbox.rscale);
            if (p > 0) {
                u += p;
                v -= p;
            }
        }
        u = Math.max(this.length2em(this.node.attributes.get('superscriptshift'), u), u);
        v = Math.max(this.length2em(this.node.attributes.get('subscriptshift'), v), v);
        q = (u - supbox.d * supbox.rscale) - (subbox.h * subbox.rscale - v);
        this.UVQ = [u, -v, q];
        return this.UVQ;
    };
    return CHTMLmsubsup;
}(scriptbase_js_1.CHTMLscriptbase));
CHTMLmsubsup.kind = msubsup_js_1.MmlMsubsup.prototype.kind;
CHTMLmsubsup.styles = {
    'mjx-script': {
        display: 'inline-block',
        'padding-right': '.05em'
    },
    'mjx-script > *': {
        display: 'block'
    }
};
CHTMLmsubsup.noIC = true;
exports.CHTMLmsubsup = CHTMLmsubsup;
//# sourceMappingURL=msubsup.js.map