"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
Object.defineProperty(exports, "__esModule", { value: true });
var Wrapper_js_1 = require("../Wrapper.js");
var mtable_js_1 = require("../../../core/MmlTree/MmlNodes/mtable.js");
var CHTMLmtable = (function (_super) {
    __extends(CHTMLmtable, _super);
    function CHTMLmtable(factory, node, parent) {
        if (parent === void 0) { parent = null; }
        var _this = _super.call(this, factory, node, parent) || this;
        _this.numCols = 0;
        _this.numRows = 0;
        _this.numCols = _this.childNodes.map(function (row) { return row.numCells; }).reduce(function (a, b) { return Math.max(a, b); });
        _this.numRows = _this.childNodes.length;
        for (var i = 0; i < _this.numCols; i++) {
            _this.stretchColumn(i);
        }
        return _this;
    }
    CHTMLmtable.prototype.stretchColumn = function (i) {
        var stretchy = [];
        try {
            for (var _a = __values(this.childNodes), _b = _a.next(); !_b.done; _b = _a.next()) {
                var row = _b.value;
                var cell = row.childNodes[i + row.firstCell];
                if (cell) {
                    var child = cell.childNodes[0];
                    if (child.stretch.dir === 0 && child.canStretch(2)) {
                        stretchy.push(child);
                    }
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_1) throw e_1.error; }
        }
        var count = stretchy.length;
        var nodeCount = this.childNodes.length;
        if (count && nodeCount > 1) {
            var W = 0;
            var all = (count > 1 && count === nodeCount);
            try {
                for (var _d = __values(this.childNodes), _e = _d.next(); !_e.done; _e = _d.next()) {
                    var row = _e.value;
                    var cell = row.childNodes[i + row.firstCell];
                    if (cell) {
                        var child = cell.childNodes[0];
                        var noStretch = (child.stretch.dir === 0);
                        if (all || noStretch) {
                            var w = child.getBBox(noStretch).w;
                            if (w > W)
                                W = w;
                        }
                    }
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (_e && !_e.done && (_f = _d.return)) _f.call(_d);
                }
                finally { if (e_2) throw e_2.error; }
            }
            try {
                for (var stretchy_1 = __values(stretchy), stretchy_1_1 = stretchy_1.next(); !stretchy_1_1.done; stretchy_1_1 = stretchy_1.next()) {
                    var child = stretchy_1_1.value;
                    child.coreMO().getStretchedVariant([W]);
                }
            }
            catch (e_3_1) { e_3 = { error: e_3_1 }; }
            finally {
                try {
                    if (stretchy_1_1 && !stretchy_1_1.done && (_g = stretchy_1.return)) _g.call(stretchy_1);
                }
                finally { if (e_3) throw e_3.error; }
            }
        }
        var e_1, _c, e_2, _f, e_3, _g;
    };
    CHTMLmtable.prototype.toCHTML = function (parent) {
        var chtml = this.standardCHTMLnode(parent);
        var table = chtml.appendChild(this.html('mjx-itable'));
        try {
            for (var _a = __values(this.childNodes), _b = _a.next(); !_b.done; _b = _a.next()) {
                var child = _b.value;
                child.toCHTML(table);
            }
        }
        catch (e_4_1) { e_4 = { error: e_4_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_4) throw e_4.error; }
        }
        var attributes = this.node.attributes;
        var frame = attributes.get('frame') !== 'none';
        var lines = frame || attributes.get('columnlines') !== 'none' || attributes.get('rowlines') !== 'none';
        var fspacing = (lines ? this.convertLengths(this.getAttributeArray('framespacing')) : []);
        this.padRows();
        this.handleColumnAlign();
        this.handleColumnSpacing(lines, fspacing[0] || '0');
        this.handleColumnLines();
        this.handleRowAlign();
        this.handleRowSpacing(lines, fspacing[1] || '0');
        this.handleRowLines();
        this.handleFrame(frame);
        this.handleWidth();
        var e_4, _c;
    };
    CHTMLmtable.prototype.computeBBox = function (bbox) {
        var H = new Array(this.numRows).fill(0);
        var D = new Array(this.numRows).fill(0);
        var W = new Array(this.numCols).fill(0);
        for (var j = 0; j < this.numRows; j++) {
            var row = this.childNodes[j];
            for (var i = 0; i < row.childNodes.length; i++) {
                var cbox = row.childNodes[i].getBBox();
                var h_1 = Math.max(cbox.h, .75);
                var d = Math.max(cbox.d, .25);
                if (h_1 > H[j])
                    H[j] = h_1;
                if (d > D[j])
                    D[j] = d;
                if (cbox.w > W[i])
                    W[i] = cbox.w;
            }
        }
        var cMax = Math.max(0, this.numCols - 1);
        var rMax = Math.max(0, this.numRows - 1);
        var cSpace = this.convertLengths(this.getColumnAttributes('columnspacing')).slice(0, cMax);
        var rSpace = this.convertLengths(this.getRowAttributes('rowspacing')).slice(0, rMax);
        var frame = this.node.attributes.get('frame') !== 'none';
        var fSpace = (frame ? this.convertLengths(this.getAttributeArray('framespacing')) : []);
        var cLines = this.getColumnAttributes('columnlines').slice(0, cMax).map(function (x) { return (x === 'none' ? 0 : .07); });
        var rLines = this.getColumnAttributes('rowlines').slice(0, cMax).map(function (x) { return (x === 'none' ? 0 : .07); });
        var a = this.font.params.axis_height;
        var h = H.concat(D, rLines).reduce(function (a, b) { return a + b; }) + (frame ? .14 : 0) +
            rSpace.map(function (x) { return parseFloat(x); }).reduce(function (a, b) { return a + b; }) + 2 * parseFloat(fSpace[1] || '0');
        bbox.h = h / 2 + a;
        bbox.d = h / 2 - a;
        bbox.w = W.concat(cLines).reduce(function (a, b) { return a + b; }) +
            cSpace.map(function (x) { return parseFloat(x); }).reduce(function (a, b) { return a + b; }) + 2 * parseFloat(fSpace[1] || '0');
    };
    CHTMLmtable.prototype.padRows = function () {
        try {
            for (var _a = __values(Array.from(this.chtml.firstChild.childNodes)), _b = _a.next(); !_b.done; _b = _a.next()) {
                var row = _b.value;
                while (row.childNodes.length < this.numCols) {
                    row.appendChild(this.html('mjx-mtd'));
                }
            }
        }
        catch (e_5_1) { e_5 = { error: e_5_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_5) throw e_5.error; }
        }
        var e_5, _c;
    };
    CHTMLmtable.prototype.handleColumnAlign = function () {
        var colAlign = this.getColumnAttributes('columnalign') || [];
        try {
            for (var _a = __values(this.childNodes), _b = _a.next(); !_b.done; _b = _a.next()) {
                var row = _b.value;
                var aligns = this.getColumnAttributes('columnalign', row) || colAlign;
                var i = 0;
                try {
                    for (var _c = __values(row.childNodes), _d = _c.next(); !_d.done; _d = _c.next()) {
                        var cell = _d.value;
                        var align = cell.node.attributes.get('columnalign') || aligns[i++];
                        if (align !== 'center') {
                            cell.chtml.style.textAlign = align;
                        }
                    }
                }
                catch (e_6_1) { e_6 = { error: e_6_1 }; }
                finally {
                    try {
                        if (_d && !_d.done && (_e = _c.return)) _e.call(_c);
                    }
                    finally { if (e_6) throw e_6.error; }
                }
            }
        }
        catch (e_7_1) { e_7 = { error: e_7_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_f = _a.return)) _f.call(_a);
            }
            finally { if (e_7) throw e_7.error; }
        }
        var e_7, _f, e_6, _e;
    };
    CHTMLmtable.prototype.handleColumnSpacing = function (frame, fspace) {
        var spacing = this.convertLengths(this.getColumnAttributes('columnspacing'), 2);
        if (!spacing)
            return;
        spacing.unshift(fspace);
        spacing[this.numCols] = fspace;
        try {
            for (var _a = __values(this.childNodes), _b = _a.next(); !_b.done; _b = _a.next()) {
                var row = _b.value;
                var i = 0;
                try {
                    for (var _c = __values(row.childNodes), _d = _c.next(); !_d.done; _d = _c.next()) {
                        var cell = _d.value;
                        var lspace = spacing[i++];
                        var rspace = spacing[i];
                        var style = (cell ? cell.chtml : row.chtml.childNodes[i]).style;
                        if ((i > 1 || frame) && lspace !== '.5em') {
                            style.paddingLeft = lspace;
                        }
                        if ((i < this.numCols || frame) && rspace !== '.5em') {
                            style.paddingRight = rspace;
                        }
                    }
                }
                catch (e_8_1) { e_8 = { error: e_8_1 }; }
                finally {
                    try {
                        if (_d && !_d.done && (_e = _c.return)) _e.call(_c);
                    }
                    finally { if (e_8) throw e_8.error; }
                }
            }
        }
        catch (e_9_1) { e_9 = { error: e_9_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_f = _a.return)) _f.call(_a);
            }
            finally { if (e_9) throw e_9.error; }
        }
        var e_9, _f, e_8, _e;
    };
    CHTMLmtable.prototype.handleColumnLines = function () {
        if (this.node.attributes.get('columnlines') === 'none')
            return;
        var lines = this.getColumnAttributes('columnlines');
        if (!lines)
            return;
        try {
            for (var _a = __values(this.childNodes), _b = _a.next(); !_b.done; _b = _a.next()) {
                var row = _b.value;
                var i = 0;
                try {
                    for (var _c = __values(Array.from(row.chtml.childNodes).slice(1)), _d = _c.next(); !_d.done; _d = _c.next()) {
                        var cell = _d.value;
                        var line = lines[i++];
                        if (line === 'none')
                            continue;
                        cell.style.borderLeft = '.07em ' + line;
                    }
                }
                catch (e_10_1) { e_10 = { error: e_10_1 }; }
                finally {
                    try {
                        if (_d && !_d.done && (_e = _c.return)) _e.call(_c);
                    }
                    finally { if (e_10) throw e_10.error; }
                }
            }
        }
        catch (e_11_1) { e_11 = { error: e_11_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_f = _a.return)) _f.call(_a);
            }
            finally { if (e_11) throw e_11.error; }
        }
        var e_11, _f, e_10, _e;
    };
    CHTMLmtable.prototype.handleRowAlign = function () {
        var rowAlign = this.getRowAttributes('rowalign') || [];
        var i = 0;
        try {
            for (var _a = __values(this.childNodes), _b = _a.next(); !_b.done; _b = _a.next()) {
                var row = _b.value;
                var align = row.node.attributes.get('rowalign') || rowAlign[i++];
                if (align !== 'baseline') {
                    row.chtml.style.verticalAlign = align;
                }
                try {
                    for (var _c = __values(row.childNodes), _d = _c.next(); !_d.done; _d = _c.next()) {
                        var cell = _d.value;
                        var calign = cell.node.attributes.get('rowalign');
                        if (calign && calign !== align) {
                            cell.chtml.style.verticalAlign = calign;
                        }
                    }
                }
                catch (e_12_1) { e_12 = { error: e_12_1 }; }
                finally {
                    try {
                        if (_d && !_d.done && (_e = _c.return)) _e.call(_c);
                    }
                    finally { if (e_12) throw e_12.error; }
                }
            }
        }
        catch (e_13_1) { e_13 = { error: e_13_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_f = _a.return)) _f.call(_a);
            }
            finally { if (e_13) throw e_13.error; }
        }
        var e_13, _f, e_12, _e;
    };
    CHTMLmtable.prototype.handleRowSpacing = function (frame, fspacing) {
        var spacing = this.convertLengths(this.getRowAttributes('rowspacing'), 2);
        if (!spacing)
            return;
        spacing.unshift(fspacing);
        spacing[this.numRows] = fspacing;
        var i = 0;
        try {
            for (var _a = __values(this.childNodes), _b = _a.next(); !_b.done; _b = _a.next()) {
                var row = _b.value;
                var tspace = spacing[i++];
                var bspace = spacing[i];
                try {
                    for (var _c = __values(row.childNodes), _d = _c.next(); !_d.done; _d = _c.next()) {
                        var cell = _d.value;
                        var style = cell.chtml.style;
                        if ((i > 1 || frame) && tspace !== '.125em') {
                            style.paddingTop = tspace;
                        }
                        if ((i < this.numRows || frame) && bspace !== '.125em') {
                            style.paddingBottom = bspace;
                        }
                    }
                }
                catch (e_14_1) { e_14 = { error: e_14_1 }; }
                finally {
                    try {
                        if (_d && !_d.done && (_e = _c.return)) _e.call(_c);
                    }
                    finally { if (e_14) throw e_14.error; }
                }
            }
        }
        catch (e_15_1) { e_15 = { error: e_15_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_f = _a.return)) _f.call(_a);
            }
            finally { if (e_15) throw e_15.error; }
        }
        var e_15, _f, e_14, _e;
    };
    CHTMLmtable.prototype.handleRowLines = function () {
        if (this.node.attributes.get('rowlines') === 'none')
            return;
        var lines = this.getRowAttributes('rowlines');
        if (!lines)
            return;
        var i = 0;
        try {
            for (var _a = __values(this.childNodes.slice(1)), _b = _a.next(); !_b.done; _b = _a.next()) {
                var row = _b.value;
                var line = lines[i++];
                if (line === 'none')
                    continue;
                try {
                    for (var _c = __values(Array.from(row.chtml.childNodes)), _d = _c.next(); !_d.done; _d = _c.next()) {
                        var cell = _d.value;
                        cell.style.borderTop = '.07em ' + line;
                    }
                }
                catch (e_16_1) { e_16 = { error: e_16_1 }; }
                finally {
                    try {
                        if (_d && !_d.done && (_e = _c.return)) _e.call(_c);
                    }
                    finally { if (e_16) throw e_16.error; }
                }
            }
        }
        catch (e_17_1) { e_17 = { error: e_17_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_f = _a.return)) _f.call(_a);
            }
            finally { if (e_17) throw e_17.error; }
        }
        var e_17, _f, e_16, _e;
    };
    CHTMLmtable.prototype.handleFrame = function (frame) {
        if (frame) {
            this.chtml.firstChild.style.border = '.07em ' + this.node.attributes.get('frame');
        }
    };
    CHTMLmtable.prototype.handleWidth = function () {
        var w = this.node.attributes.get('width');
        if (w === 'auto')
            return;
        if (w.match(/%$/)) {
            this.bbox.pwidth = w;
            this.chtml.setAttribute('width', '%');
        }
        else {
            w = this.em(this.length2em(w));
        }
        this.chtml.style.width = w;
    };
    CHTMLmtable.prototype.getColumnAttributes = function (name, wrapper) {
        if (wrapper === void 0) { wrapper = null; }
        var columns = this.getAttributeArray(name, wrapper);
        if (columns.length === 0)
            return;
        while (columns.length < this.numCols) {
            columns.push(columns[columns.length - 1]);
        }
        return columns;
    };
    CHTMLmtable.prototype.getRowAttributes = function (name, wrapper) {
        if (wrapper === void 0) { wrapper = null; }
        var rows = this.getAttributeArray(name, wrapper);
        if (rows.length === 0)
            return;
        while (rows.length < this.numRows) {
            rows.push(rows[rows.length - 1]);
        }
        return rows;
    };
    CHTMLmtable.prototype.getAttributeArray = function (name, wrapper) {
        if (wrapper === void 0) { wrapper = null; }
        var value = (wrapper || this).node.attributes.get(name);
        if (!value)
            return [];
        return value.replace(/^\s+/, '').replace(/\s+$/, '').replace(/\s+/g, ' ').split(/ /);
    };
    CHTMLmtable.prototype.convertLengths = function (list, n) {
        var _this = this;
        if (n === void 0) { n = 1; }
        if (!list)
            return;
        return list.map(function (x) { return _this.em(_this.length2em(x) / n); });
    };
    return CHTMLmtable;
}(Wrapper_js_1.CHTMLWrapper));
CHTMLmtable.kind = mtable_js_1.MmlMtable.prototype.kind;
CHTMLmtable.styles = {
    'mjx-mtable': {
        'vertical-align': '.25em',
        'text-align': 'center'
    },
    'mjx-mtable > mjx-itable': {
        'vertical-align': 'middle',
        'text-align': 'left'
    },
    'mjx-mtable[width="%"] > mjx-itable': {
        width: '100%'
    }
};
exports.CHTMLmtable = CHTMLmtable;
//# sourceMappingURL=mtable.js.map