"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
Object.defineProperty(exports, "__esModule", { value: true });
var Wrapper_js_1 = require("../Wrapper.js");
var mtr_js_1 = require("../../../core/MmlTree/MmlNodes/mtr.js");
var CHTMLmtr = (function (_super) {
    __extends(CHTMLmtr, _super);
    function CHTMLmtr(factory, node, parent) {
        if (parent === void 0) { parent = null; }
        var _this = _super.call(this, factory, node, parent) || this;
        _this.stretchChildren();
        return _this;
    }
    Object.defineProperty(CHTMLmtr.prototype, "numCells", {
        get: function () {
            return this.childNodes.length;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CHTMLmtr.prototype, "firstCell", {
        get: function () {
            return 0;
        },
        enumerable: true,
        configurable: true
    });
    CHTMLmtr.prototype.getChildBBoxes = function () {
        return this.childNodes.map(function (cell) { return cell.getBBox(); });
    };
    CHTMLmtr.prototype.stretchChildren = function () {
        var stretchy = [];
        var children = (this.firstCell ? this.childNodes.slice(this.firstCell) : this.childNodes);
        try {
            for (var children_1 = __values(children), children_1_1 = children_1.next(); !children_1_1.done; children_1_1 = children_1.next()) {
                var mtd = children_1_1.value;
                var child = mtd.childNodes[0];
                if (child.canStretch(1)) {
                    stretchy.push(child);
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (children_1_1 && !children_1_1.done && (_a = children_1.return)) _a.call(children_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        var count = stretchy.length;
        var nodeCount = this.childNodes.length;
        if (count && nodeCount > 1) {
            var H = 0, D = 0;
            var all = (count > 1 && count === nodeCount);
            try {
                for (var children_2 = __values(children), children_2_1 = children_2.next(); !children_2_1.done; children_2_1 = children_2.next()) {
                    var mtd = children_2_1.value;
                    var child = mtd.childNodes[0];
                    var noStretch = (child.stretch.dir === 0);
                    if (all || noStretch) {
                        var _b = child.getBBox(noStretch), h = _b.h, d = _b.d;
                        if (h > H)
                            H = h;
                        if (d > D)
                            D = d;
                    }
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (children_2_1 && !children_2_1.done && (_c = children_2.return)) _c.call(children_2);
                }
                finally { if (e_2) throw e_2.error; }
            }
            try {
                for (var stretchy_1 = __values(stretchy), stretchy_1_1 = stretchy_1.next(); !stretchy_1_1.done; stretchy_1_1 = stretchy_1.next()) {
                    var child = stretchy_1_1.value;
                    child.coreMO().getStretchedVariant([H, D]);
                }
            }
            catch (e_3_1) { e_3 = { error: e_3_1 }; }
            finally {
                try {
                    if (stretchy_1_1 && !stretchy_1_1.done && (_d = stretchy_1.return)) _d.call(stretchy_1);
                }
                finally { if (e_3) throw e_3.error; }
            }
        }
        var e_1, _a, e_2, _c, e_3, _d;
    };
    return CHTMLmtr;
}(Wrapper_js_1.CHTMLWrapper));
CHTMLmtr.kind = mtr_js_1.MmlMtr.prototype.kind;
CHTMLmtr.styles = {
    'mjx-mtr': {
        display: 'table-row',
    }
};
exports.CHTMLmtr = CHTMLmtr;
var CHTMLmlabeledtr = (function (_super) {
    __extends(CHTMLmlabeledtr, _super);
    function CHTMLmlabeledtr() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CHTMLmlabeledtr.prototype.toCHTML = function (parent) {
        _super.prototype.toCHTML.call(this, parent);
        var row = this.chtml;
        if (row.firstChild) {
            row.removeChild(row.firstChild);
        }
    };
    Object.defineProperty(CHTMLmlabeledtr.prototype, "numCells", {
        get: function () {
            return Math.max(0, this.childNodes.length - 1);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CHTMLmlabeledtr.prototype, "firstCell", {
        get: function () {
            return 1;
        },
        enumerable: true,
        configurable: true
    });
    CHTMLmlabeledtr.prototype.getChildBBoxes = function () {
        return this.childNodes.slice(1).map(function (cell) { return cell.getBBox(); });
    };
    return CHTMLmlabeledtr;
}(Wrapper_js_1.CHTMLWrapper));
CHTMLmlabeledtr.kind = mtr_js_1.MmlMlabeledtr.prototype.kind;
CHTMLmlabeledtr.styles = {
    'mjx-mlabeledtr': {
        display: 'table-row'
    }
};
exports.CHTMLmlabeledtr = CHTMLmlabeledtr;
//# sourceMappingURL=mtr.js.map