"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var msubsup_js_1 = require("./msubsup.js");
var munderover_js_1 = require("../../../core/MmlTree/MmlNodes/munderover.js");
var DELTA = 1.1;
var CHTMLmunder = (function (_super) {
    __extends(CHTMLmunder, _super);
    function CHTMLmunder(factory, node, parent) {
        if (parent === void 0) { parent = null; }
        var _this = _super.call(this, factory, node, parent) || this;
        _this.stretchChildren();
        return _this;
    }
    Object.defineProperty(CHTMLmunder.prototype, "script", {
        get: function () {
            return this.childNodes[this.node.under];
        },
        enumerable: true,
        configurable: true
    });
    CHTMLmunder.prototype.toCHTML = function (parent) {
        if (this.hasMovableLimits()) {
            _super.prototype.toCHTML.call(this, parent);
            this.chtml.setAttribute('limits', 'false');
            return;
        }
        this.chtml = this.standardCHTMLnode(parent);
        var base = this.chtml.appendChild(this.html('mjx-row')).appendChild(this.html('mjx-base'));
        var under = this.chtml.appendChild(this.html('mjx-row')).appendChild(this.html('mjx-under'));
        this.baseChild.toCHTML(base);
        this.script.toCHTML(under);
        var basebox = this.baseChild.getBBox();
        var underbox = this.script.getBBox();
        var _a = __read(this.getUnderKV(basebox, underbox), 2), k = _a[0], v = _a[1];
        var delta = DELTA * this.baseCore.bbox.ic / 2;
        under.style.paddingTop = this.em(k);
        this.setDeltaW([base, under], this.getDeltaW([basebox, underbox], [0, -delta]));
    };
    CHTMLmunder.prototype.computeBBox = function (bbox) {
        if (this.hasMovableLimits()) {
            _super.prototype.computeBBox.call(this, bbox);
            return;
        }
        bbox.empty();
        var basebox = this.baseChild.getBBox();
        var underbox = this.script.getBBox();
        var _a = __read(this.getUnderKV(basebox, underbox), 2), k = _a[0], v = _a[1];
        var delta = DELTA * this.baseCore.bbox.ic / 2;
        var _b = __read(this.getDeltaW([basebox, underbox], [0, -delta]), 2), bw = _b[0], uw = _b[1];
        bbox.combine(basebox, bw, 0);
        bbox.combine(underbox, uw, v);
        bbox.d += this.font.params.big_op_spacing5;
        bbox.clean();
    };
    return CHTMLmunder;
}(msubsup_js_1.CHTMLmsub));
CHTMLmunder.kind = munderover_js_1.MmlMunder.prototype.kind;
CHTMLmunder.useIC = true;
CHTMLmunder.styles = {
    'mjx-munder:not([limits="false"])': {
        display: 'inline-table',
    },
    'mjx-munder > mjx-row': {
        'text-align': 'left'
    },
    'mjx-under': {
        'padding-bottom': '.1em'
    }
};
exports.CHTMLmunder = CHTMLmunder;
var CHTMLmover = (function (_super) {
    __extends(CHTMLmover, _super);
    function CHTMLmover(factory, node, parent) {
        if (parent === void 0) { parent = null; }
        var _this = _super.call(this, factory, node, parent) || this;
        _this.stretchChildren();
        return _this;
    }
    Object.defineProperty(CHTMLmover.prototype, "script", {
        get: function () {
            return this.childNodes[this.node.over];
        },
        enumerable: true,
        configurable: true
    });
    CHTMLmover.prototype.toCHTML = function (parent) {
        if (this.hasMovableLimits()) {
            _super.prototype.toCHTML.call(this, parent);
            this.chtml.setAttribute('limits', 'false');
            return;
        }
        this.chtml = this.standardCHTMLnode(parent);
        var over = this.chtml.appendChild(this.html('mjx-over'));
        var base = this.chtml.appendChild(this.html('mjx-base'));
        this.script.toCHTML(over);
        this.baseChild.toCHTML(base);
        var overbox = this.script.getBBox();
        var basebox = this.baseChild.getBBox();
        var _a = __read(this.getOverKU(basebox, overbox), 2), k = _a[0], u = _a[1];
        var delta = DELTA * this.baseCore.bbox.ic / 2;
        over.style.paddingBottom = this.em(k);
        this.setDeltaW([base, over], this.getDeltaW([basebox, overbox], [0, delta]));
        if (overbox.d < 0) {
            over.style.marginBottom = this.em(overbox.d * overbox.rscale);
        }
    };
    CHTMLmover.prototype.computeBBox = function (bbox) {
        if (this.hasMovableLimits()) {
            _super.prototype.computeBBox.call(this, bbox);
            return;
        }
        bbox.empty();
        var basebox = this.baseChild.getBBox();
        var overbox = this.script.getBBox();
        var _a = __read(this.getOverKU(basebox, overbox), 2), k = _a[0], u = _a[1];
        var delta = DELTA * this.baseCore.bbox.ic / 2;
        var _b = __read(this.getDeltaW([basebox, overbox], [0, delta]), 2), bw = _b[0], ow = _b[1];
        bbox.combine(basebox, bw, 0);
        bbox.combine(overbox, ow, u);
        bbox.h += this.font.params.big_op_spacing5;
        bbox.clean();
    };
    return CHTMLmover;
}(msubsup_js_1.CHTMLmsup));
CHTMLmover.kind = munderover_js_1.MmlMover.prototype.kind;
CHTMLmover.useIC = true;
CHTMLmover.styles = {
    'mjx-mover:not([limits="false"])': {
        'padding-top': '.1em'
    },
    'mjx-mover:not([limits="false"]) > *': {
        display: 'block',
        'text-align': 'left'
    }
};
exports.CHTMLmover = CHTMLmover;
var CHTMLmunderover = (function (_super) {
    __extends(CHTMLmunderover, _super);
    function CHTMLmunderover(factory, node, parent) {
        if (parent === void 0) { parent = null; }
        var _this = _super.call(this, factory, node, parent) || this;
        _this.stretchChildren();
        return _this;
    }
    Object.defineProperty(CHTMLmunderover.prototype, "underChild", {
        get: function () {
            return this.childNodes[this.node.under];
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CHTMLmunderover.prototype, "overChild", {
        get: function () {
            return this.childNodes[this.node.over];
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CHTMLmunderover.prototype, "subChild", {
        get: function () {
            return this.underChild;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CHTMLmunderover.prototype, "supChild", {
        get: function () {
            return this.overChild;
        },
        enumerable: true,
        configurable: true
    });
    CHTMLmunderover.prototype.toCHTML = function (parent) {
        if (this.hasMovableLimits()) {
            _super.prototype.toCHTML.call(this, parent);
            this.chtml.setAttribute('limits', 'false');
            return;
        }
        this.chtml = this.standardCHTMLnode(parent);
        var over = this.chtml.appendChild(this.html('mjx-over'));
        var table = this.chtml.appendChild(this.html('mjx-box')).appendChild(this.html('mjx-munder'));
        var base = table.appendChild(this.html('mjx-row')).appendChild(this.html('mjx-base'));
        var under = table.appendChild(this.html('mjx-row')).appendChild(this.html('mjx-under'));
        this.overChild.toCHTML(over);
        this.baseChild.toCHTML(base);
        this.underChild.toCHTML(under);
        var overbox = this.overChild.getBBox();
        var basebox = this.baseChild.getBBox();
        var underbox = this.underChild.getBBox();
        var _a = __read(this.getOverKU(basebox, overbox), 2), ok = _a[0], u = _a[1];
        var _b = __read(this.getUnderKV(basebox, underbox), 2), uk = _b[0], v = _b[1];
        var delta = DELTA * this.baseCore.bbox.ic / 2;
        over.style.paddingBottom = this.em(ok);
        under.style.paddingTop = this.em(uk);
        this.setDeltaW([base, under, over], this.getDeltaW([basebox, underbox, overbox], [0, -delta, delta]));
        if (overbox.d < 0) {
            over.style.marginBottom = this.em(overbox.d * overbox.rscale);
        }
    };
    CHTMLmunderover.prototype.computeBBox = function (bbox) {
        if (this.hasMovableLimits()) {
            _super.prototype.computeBBox.call(this, bbox);
            return;
        }
        bbox.empty();
        var overbox = this.overChild.getBBox();
        var basebox = this.baseChild.getBBox();
        var underbox = this.underChild.getBBox();
        var _a = __read(this.getOverKU(basebox, overbox), 2), ok = _a[0], u = _a[1];
        var _b = __read(this.getUnderKV(basebox, underbox), 2), uk = _b[0], v = _b[1];
        var delta = DELTA * this.baseCore.bbox.ic / 2;
        var _c = __read(this.getDeltaW([basebox, underbox, overbox], [0, -delta, delta]), 3), bw = _c[0], uw = _c[1], ow = _c[2];
        bbox.combine(basebox, bw, 0);
        bbox.combine(overbox, ow, u);
        bbox.combine(underbox, uw, v);
        var z = this.font.params.big_op_spacing5;
        bbox.h += z;
        bbox.d += z;
        bbox.clean();
    };
    return CHTMLmunderover;
}(msubsup_js_1.CHTMLmsubsup));
CHTMLmunderover.kind = munderover_js_1.MmlMunderover.prototype.kind;
CHTMLmunderover.useIC = true;
CHTMLmunderover.styles = {
    'mjx-munderover:not([limits="false"])': {
        'padding-top': '.1em'
    },
    'mjx-munderover:not([limits="false"]) > *': {
        display: 'block'
    },
};
exports.CHTMLmunderover = CHTMLmunderover;
//# sourceMappingURL=munderover.js.map